<?php
/**
 * The admin-specific functionality of the plugin.
 *
 * Defines the plugin name, version, and two examples hooks for how to
 * enqueue the admin-specific stylesheet and JavaScript.
 *
 * @package    WpSecure
 * @subpackage WpSecure/includes
 * @author     WpSecure <contact@WpSecure.com>
 */
class WpSecure_Admin {

	/**
	 * The ID of this plugin.
	 */
	private $plugin_name;

	/**
	 * The version of this plugin.
	 */
	private $version;
	/**
	 * Initialize the class and set its properties.
	 */
	public function __construct( $plugin_name, $version ) {
		$this->plugin_name = $plugin_name.'-admin';
		$this->version = $version;
		
	}

	
	/**
	 * Register the stylesheets for the admin area.
	 */
	public function enqueue_styles() {
		//wp_enqueue_style( $this->plugin_name, plugin_dir_url( __FILE__ ) . 'css/wpsecure-admin.css', array(), $this->version, 'all' );
    }

	/**
	 * Register the JavaScript for the admin area.
	 */
	public function enqueue_scripts() {
		//wp_enqueue_script( $this->plugin_name, plugin_dir_url( __FILE__ ) . 'js/wpsecure-admin.js', array( 'jquery' ), $this->version, false );
	}
	
	/**
	 * Register admin menu.
	 */
	public function wpsecure_admin_menu() {
		add_menu_page('WpSecure', 'WP Secure', 'manage_options', 'wpsecure', array($this, 'wps_admin_page') );
	}

    /**
	 * wpsecure setting page.
	 */	
	public function wps_admin_page() {
		include_once( 'partials/wps-admin-display.php' );
	}	
	
}
