<script src="https://cdn.tailwindcss.com/3.0.24"></script>
<script>
  tailwind.config = {
	theme: {
	  extend: {
		colors: {
		  clifford: "#da373d",
		},
	  },
	},
  };
</script>
<style>
.wps_main_wrap{margin:20px 15px 20px 0;font-family: sans-serif;}
.wps_container{width:100%;}

.wps_main_wrap .wps_main{}
.wps_main_wrap .wps_main h2{
    padding: 20px;
    font-size: 2rem;
    background:#1d2327;
    color: #fff;
    letter-spacing: 5px;
	margin-bottom: 20px;
	font-weight:bold;
}
</style>

<div class="wps_main_wrap">
	<div class="wps_container">
		<div class="wps_main" style="min-height:auto !important;">
        <h2>WP Secure</h2>
		<div class="container mx-auto ">
		<?php if(isset($success_msg)){ echo $success_msg; }?>
		<div class="flex flex-wrap" id="tabs-id">
			<div class="w-full font-bold">
			  <ul class="flex mb-0 list-none flex-wrap pt-3 pb-4 flex-row">
				<li class="-mb-px mr-2 last:mr-0 flex-auto text-center pb-2">
				  <a class="text-xs font-bold uppercase px-5 py-3 cursor-pointer shadow-lg rounded block leading-normal text-white bg-blue-600"
					onclick="changeAtiveTab(event,'tab-URL')" >
					<i class="fas fa-space-shuttle text-base mr-1"></i> Change
					wp-login URL
				  </a>
				</li>
				<li class="-mb-px mr-2 last:mr-0 flex-auto text-center pb-2">
				  <a class="text-xs font-bold uppercase px-5 py-3 cursor-pointer shadow-lg rounded block leading-normal text-blue-600 bg-white"
					onclick="changeAtiveTab(event,'tab-Hide')" >
					<i class="fas fa-cog text-base mr-1"></i> Hide
				  </a>
				</li>
				<li class="-mb-px mr-2 last:mr-0 flex-auto text-center pb-2">
				  <a class="text-xs font-bold uppercase px-5 py-3 shadow-lg cursor-pointer rounded block leading-normal text-blue-600 bg-white"
					onclick="changeAtiveTab(event,'tab-Redirect')" >
					<i class="fas fa-briefcase text-base mr-1"></i> Brute Force Attack Protection
				  </a>
				</li>
				<li class="-mb-px mr-2 last:mr-0 flex-auto text-center pb-2">
				  <a class="text-xs font-bold uppercase px-5 py-3 shadow-lg cursor-pointer rounded block leading-normal text-blue-600 bg-white"
					onclick="changeAtiveTab(event,'tab-plugins')" >
					<i class="fas fa-briefcase text-base mr-1"></i> 2 factor authentication
				  </a>
				</li>
			  </ul>
			  <div class="relative flex flex-col min-w-0 break-words bg-white w-full mb-6 shadow-lg rounded" >
				<div class="lg:px-4 lg:py-5 p-2 flex-auto">
				  <form method="post" >
				  <div class="tab-content tab-space">
					<div class="block" id="tab-URL">
					  <div class="w-full bg-yellow-100 rounded-lg py-3 px-6 mb-4 text-base text-yellow-700 mb-3" role="alert" >Please be careful while using those features - watch the training videos first before use or tick any of them.</div>
					  <div class="lg:flex md:flex justify-between w-full lg:w-10/12 pb-4">
						<div class="w-full lg:w-1/4 pb-4">
						  <h1>New Login Url</h1>
						</div>
						<div class="w-full">
						  <div>
							<code><?php echo esc_url( site_url() ); ?>/</code> <input
							  name="new_login_url"
                              id="new_login_url" 							  
							  class="w-4/12 border rounded px-2 py-2"
							  type="text"
							  placeholder="login" 
							  value="<?php echo (isset($wpsecure['new_login_url']))?$wpsecure['new_login_url']:''; ?>"
							/>
						  </div>
						  <div><i>Change the login URL and prevent users from accessing <code><?php echo esc_url( site_url() ); ?>/wp-login.php</code></i></div>
						  
						</div>
					  </div>
					  <!--<div class="lg:flex md:flex justify-between w-full lg:w-10/12 pb-4">
						<div class="w-full lg:w-1/4 pb-4">
						  <h1>Redirect Admin Area</h1>
						</div>
						<div class="w-full">
						  <div>
							<code><?php echo esc_url( site_url() ); ?>/</code> <input
							  name="admin_redirect_slug"
                              id="admin_redirect_slug" 							  
							  class="w-4/12 border rounded px-2 py-2"
							  type="text"
							  placeholder="404" 
							  value="<?php echo (isset($wpsecure['admin_redirect_slug']))?$wpsecure['admin_redirect_slug']:''; ?>"
							/>
						  </div>
						  <div><i>Redirect non-logged-in users that try to access <code><?php echo esc_url( site_url() ); ?>/wp-admin/</code></i></div>
						  
						</div>
					  </div>	-->				  
					  <button type="submit" name="wps_submit" class="bg-blue-500 px-10 py-2 text-white mt-4">
						Save
					  </button>
					</div>
					<div class="hidden" id="tab-Hide">
					<div class="w-full bg-yellow-100 rounded-lg py-3 px-6 mb-4 text-base text-yellow-700 mb-3" role="alert" >Please be careful while using those features - watch the training videos first before use or tick any of them.</div>					
					<div class="lg:flex md:flex items-center justify-between mt-4 w-full lg:w-8/12" >
						<div class="w-full lg:w-1/4 p-2">
						  <h1>Hide Admin</h1>
						</div>
						<div class="flex items-center w-full">
						  <input type="checkbox" name="hide_admin" id="hide_admin" value="on" <?php echo (isset($wpsecure['hide_admin']) && $wpsecure['hide_admin']=='on')?" checked ":""; ?> />

						  <h1 class="mx-2">
							Hide wp-admin folder and its file for untrusted users
						  </h1>
						</div>
					</div>
					<div class="lg:flex md:flex items-center justify-between mt-4 w-full lg:w-8/12" >
						<div class="w-full lg:w-1/4 p-2">
						  <h1>Full Hide</h1>
						</div>
						<div class="flex items-center w-full">
						  <input type="checkbox" name="full_hide" id="full_hide" value="on" <?php echo (isset($wpsecure['full_hide']) && $wpsecure['full_hide']=='on')?" checked ":""; ?> />

						  <h1 class="mx-2">
							 Enables to hide assets paths (disable if you use more than one domain)
						  </h1>
						</div>
					</div>
					<div class="lg:flex md:flex items-center justify-between mt-4 w-full lg:w-8/12" >
						<div class="w-full lg:w-1/4 p-2">
						  <h1>Hide Other Files</h1>
						</div>
						<div class="flex items-center w-full">
						  <input type="checkbox" name="hide_other_files" id="hide_other_files" value="on" <?php echo (isset($wpsecure['hide_other_files']) && $wpsecure['hide_other_files']=='on')?" checked ":""; ?> />

						  <h1 class="mx-2">
							 Hide license.txt, wp-includes, wp-content/debug.log, etc.
						  </h1>
						</div>
					</div>
					<div class="lg:flex md:flex items-center justify-between mt-4 w-full lg:w-8/12" >
						<div class="w-full lg:w-1/4 p-2">
						  <h1>Directory List</h1>
						</div>
						<div class="flex items-center w-full">
						  <input type="checkbox" name="disable_directory_listing" id="disable_directory_listing" value="on" <?php echo (isset($wpsecure['disable_directory_listing']) && $wpsecure['disable_directory_listing']=='on')?" checked ":""; ?> />
						  <h1 class="mx-2">
							Disable directory listing and hide other .txt files.
						  </h1>
						</div>
					</div>
					<div class="lg:flex md:flex items-center justify-between w-full mt-4 lg:w-8/12" >
						<div class="w-full lg:w-1/4 p-2 ">
						  <h1>Canonical Redirect</h1>
						</div>
						<div class="flex items-center w-full ">
						  <input type="checkbox" name="disable_canonical_redirect" id="disable_canonical_redirect" value="on" <?php echo (isset($wpsecure['disable_canonical_redirect']) && $wpsecure['disable_canonical_redirect']=='on')?" checked ":""; ?> />
						  <h1 class="mx-2">
							Disable canonical redirect. This is require when you want to use URL queries.
						  </h1>
						</div>
					</div>
					<!--<div class="lg:flex md:flex items-center justify-between w-full mt-4 lg:w-8/12" >
					  <div class="w-full lg:w-1/4 p-2 ">
						<h1>Hide popular plugins</h1>
					  </div>
					  <div class="flex items-center w-full ">
						<input type="checkbox" name="hide_popular_plugin" id="hide_popular_plugin" value="on" <?php echo (isset($wpsecure['hide_popular_plugin']) && $wpsecure['hide_popular_plugin']=='on')?" checked ":""; ?> />

						<h1 class="mx-2">
						  Automatically hide popular plugins (woocommerce, elementor, gravity forms, jetpack, wprocket)
						</h1>
					  </div>
					</div>-->

					  <div class="lg:flex md:flex items-center justify-between w-full lg:w-8/12" >
						<div class="w-full lg:w-1/4 p-2"></div>
						<div class="flex items-center w-full">
						  <button type="submit" name="wps_submit" class="bg-blue-500 px-10 py-2 text-white mt-4">
							Save
						  </button>
						</div>
					  </div>
					</div>
					<div class="hidden" id="tab-Redirect">
					  <div class="lg:flex md:flex items-center justify-between w-full lg:w-8/12" >
						<div class="w-full p-2">
						  <h1 class="pb-4">Brute Force Attack Protection</h1>
						  <div class="flex items-center w-full pb-4">
							<table class="form-table">
								<tr>
									<th scope="row" valign="top"><label for="max_retries">Max Retries</label></th>
									<td>
										<input type="text" size="3" value="<?php echo (isset($wpsecure['max_retries']))?$wpsecure['max_retries']:3; ?>" name="max_retries" id="max_retries" /> <?php echo __('Maximum failed attempts allowed before lockout','loginizer'); ?> <br />
									</td>
								</tr>
								<tr>
									<th scope="row" valign="top"><label for="lockout_time"><?php echo __('Lockout Time','loginizer'); ?></label></th>
									<td>
									<input type="text" size="3" value="<?php echo (!empty($wpsecure['lockout_time']) ? $wpsecure['lockout_time'] :900) / 60; ?>" name="lockout_time" id="lockout_time" /> <?php echo __('minutes','loginizer'); ?> <br />
									</td>
								</tr>
								<tr>
									<th scope="row" valign="top"><label for="max_lockouts"><?php echo __('Max Lockouts','loginizer'); ?></label></th>
									<td>
										<input type="text" size="3" value="<?php echo (isset($wpsecure['max_lockouts']))?$wpsecure['max_lockouts']:5; ?>" name="max_lockouts" id="max_lockouts" /> <?php echo __('','loginizer'); ?> <br />
									</td>
								</tr>
								<tr>
									<th scope="row" valign="top"><label for="lockouts_extend"><?php echo __('Extend Lockout','loginizer'); ?></label></th>
									<td>
										<input type="text" size="3" value="<?php echo (!empty($wpsecure['lockouts_extend']) ? $wpsecure['lockouts_extend'] : 86400) / 60 / 60; ?>" name="lockouts_extend" id="lockouts_extend" /> <?php echo __('hours. Extend Lockout time after Max Lockouts','loginizer'); ?> <br />
									</td>
								</tr>
								<tr>
									<th scope="row" valign="top"><label for="reset_retries"><?php echo __('Reset Retries','loginizer'); ?></label></th>
									<td>
										<input type="text" size="3" value="<?php echo (!empty($wpsecure['reset_retries']) ? $wpsecure['reset_retries'] : 86400) / 60 / 60; ?>" name="reset_retries" id="reset_retries" /> <?php echo __('hours','loginizer'); ?> <br />
									</td>
								</tr>
								<tr>
									<th scope="row" valign="top"><label for="notify_email"><?php echo __('Email Notification','loginizer'); ?></label></th>
									<td>
										<?php echo __('after ','loginizer'); ?>
										<input type="text" size="3" value="<?php echo (!empty($wpsecure['notify_email']) ? $wpsecure['notify_email'] : 0); ?>" name="notify_email" id="notify_email" /> <?php echo __('lockouts <br />0 to disable email notifications','loginizer'); ?>
									</td>
								</tr>
								<tr>
									<th scope="row" valign="top"><label for="notify_email_address"><?php echo __('Email Address','loginizer'); ?></label></th>
									<td>
										<input type="text" value="<?php echo (!empty($wpsecure['notify_email_address']) ? $wpsecure['notify_email_address'] : ''); ?>" name="notify_email_address" id="notify_email_address" size="30" /> <?php echo __('<br />failed login attempts notifications will be sent to this email','loginizer'); ?>
									</td>
								</tr>
							</table>
						  </div>
						  <button type="submit" name="wps_submit" class="bg-blue-500 px-10 py-2 text-white">
							Save
						  </button>
						</div>
					  </div>
					</div>
					<div class="hidden" id="tab-plugins">
					  <div class="lg:flex md:flex items-center justify-between w-full lg:w-8/12" >
						<div class="w-full p-2">
						  <h1 class="pb-4">2 factor authentication</h1>
						  <div class="flex items-center w-full pb-4">
						<div class="w-full lg:w-1/4 pb-4">
						  <h1>Pin Code</h1>
						</div>
						<div class="w-full">
						  <div>
							<input
							  name="pin_code"
                              id="pin_code" 							  
							  class="w-4/12 border rounded px-2 py-2"
							  type="text"
							  placeholder="Enter Pin Code..." 
							  value="<?php echo (isset($wpsecure['pin_code']))?$wpsecure['pin_code']:''; ?>"
							/>
						  </div>
						  <div>
						  </div>
						  
						</div>
						  </div>
						  <button type="submit" name="wps_submit" class="bg-blue-500 px-10 py-2 text-white">
							Save
						  </button>
						</div>
						
					  </div>
					</div>
				  </div>
				  </form>
				</div>
			  </div>
			</div>
		</div>
		<script type="text/javascript">
			function changeAtiveTab(event, tabID) {
			  let element = event.target;
			  while (element.nodeName !== "A") {
				element = element.parentNode;
			  }
			  ulElement = element.parentNode.parentNode;
			  aElements = ulElement.querySelectorAll("li > a");
			  tabContents = document
				.getElementById("tabs-id")
				.querySelectorAll(".tab-content > div");
			  for (let i = 0; i < aElements.length; i++) {
				aElements[i].classList.remove("text-white");
				aElements[i].classList.remove("bg-blue-600");
				aElements[i].classList.add("text-blue-600");
				aElements[i].classList.add("bg-white");
				tabContents[i].classList.add("hidden");
				tabContents[i].classList.remove("block");
			  }
			  element.classList.remove("text-blue-600");
			  element.classList.remove("bg-white");
			  element.classList.add("text-white");
			  element.classList.add("bg-blue-600");
			  document.getElementById(tabID).classList.remove("hidden");
			  document.getElementById(tabID).classList.add("block");
			}
		</script>
		</div>
		</div>
    </div>
</div>
<script>
//$('.alert_msg').delay(5000).fadeOut('slow');
</script>