<?php
/**
 * The admin-specific functionality of the plugin.
 *
 * Defines the plugin name, version, and two examples hooks for how to
 * enqueue the admin-specific stylesheet and JavaScript.
 *
 * @package    WpSecure
 * @subpackage WpSecure/includes
 * @author     WpSecure <contact@WpSecure.com>
 */
class WpSecure2fauth {
    private $wpsecure;
	/**
	 * Initialize the class and set its properties.
	 */
	public function __construct( $wpsecure ) {
		$this->wpsecure = $wpsecure;
		
        //echo"<pre>";print_r($this->wpsecure);echo"</pre>";

		if(isset($this->wpsecure['pin_code']) && $this->wpsecure['pin_code']!=''){
			add_action( 'login_form', array( &$this,'wps_add_login_fields') );
            add_filter( 'wp_authenticate_user', array( &$this,'wps_check_pin_status') );
		} 
	}


	public function wps_add_login_fields() {
	 
		//Get and set any values already sent
		$user_extra = ( isset( $_POST['wps_pincode'] ) ) ? $_POST['wps_pincode'] : '';
		?>
	 
		<p>
			<label for="user_extra"><?php _e('PIN Code','mydomain') ?><br />
				<input type="text" name="wps_pincode" id="wps_pincode" class="input" value="<?php echo esc_attr(stripslashes($user_extra)); ?>" size="25" /></label>
		</p>
	 
		<?php
	}

	public function wps_check_pin_status( WP_User $user ) {
		$pincode = ( isset( $_POST['wps_pincode'] ) ) ? $_POST['wps_pincode'] : '';

		$status = get_user_meta( $user->ID, 'user_status' );
		$mypincode = $this->wpsecure['pin_code'];
	 
		if ( $mypincode != $pincode ) {
			$message = esc_html__( 'User not verified.', 'text-domain');
			return new WP_Error( 'user_not_verified', $message );
	   }
	 
		return $user;
	}
	
}
