<?php
/**
 * The public-facing functionality of the plugin.
 *
 * Defines the plugin name, version, and two examples hooks for how to
 * enqueue the public-facing stylesheet and JavaScript.
 *
 * @package    wptvshop
 * @subpackage wptvshop/includes
 * @author     wptvshop <contact@wptvshop.com>
 */
class WpSecureHidePaths {

	private $wpsecure;

    const title = WPS_TITLE;
    const ver = WPS_VERSION;
    const slug = 'wps_options';
    const path = WPS_PATH;
    const dir = WPS_DIR;
    const url = WPS_URL;
    const main_file = WPS_FILE;

    private $s;
    private $sub_folder;
    private $is_subdir_mu;
    private $blog_path;

    private $trust_key;
    private $short_prefix;

    private $post_replace_old = array();
    private $post_replace_new = array();

    private $post_preg_replace_new = array();
    private $post_preg_replace_old = array();

    private $partial_replace_old = array();
    private $partial_replace_new = array();

    private $top_replace_old = array();
    private $top_replace_new = array();

    private $partial_preg_replace_new = array();
    private $partial_preg_replace_old = array();

    private $replace_old = array();
    private $replace_new = array();

    private $preg_replace_old = array();
    private $preg_replace_new = array();

    private $admin_replace_old = array();
    private $admin_replace_new = array();

    private $auto_replace_urls = array(); 
    private $auto_config_internal_css;
    private $auto_config_internal_js;

    private $none_replaced_buffer = '';
	/**
	 * Initialize the class and set its properties.
	 */
	public function __construct( $wpsecure ) {
		//global $wpsecure;
		//echo"<pre>";print_r($wpsecure);echo"</pre>";
		
		$this->hide_admin =(isset($wpsecure['hide_admin'])?$wpsecure['hide_admin']:'');
		$this->hide_other_files=(isset($wpsecure['hide_other_files'])?$wpsecure['hide_other_files']:'');
		$this->new_admin_path='';
		
		$this->hide_wp_login='';
		$this->new_login_path='';
		
		$this->full_hide=(isset($wpsecure['full_hide'])?$wpsecure['full_hide']:'');
		$this->disable_directory_listing=(isset($wpsecure['disable_directory_listing'])?$wpsecure['disable_directory_listing']:'');
		
		$this->disable_canonical_redirect=(isset($wpsecure['disable_canonical_redirect'])?$wpsecure['disable_canonical_redirect']:'');
		$this->auto_config_plugins='';
		
		$this->avoid_direct_access='';
		
		
		require_once('load.php');
		
	}

    function add_login_key_to_action_from($url, $path, $scheme, $blog_id)

    {

        if ($this->opt('login_query'))
            $login_query = $this->opt('login_query');
        else
            $login_query = 'wps_options';



        if (trim($this->new_login_path, ' /') && trim($this->new_login_path, ' /') != 'wp-login.php')

            return str_replace('wp-login.php', trim($this->new_login_path, ' /'), $url);



        if ($url && $this->h->str_contains($url, 'wp-login.php'))

            if ($scheme == 'login' || $scheme == 'login_post')

                return add_query_arg($login_query, $this->opt('admin_key'), $url);





        return $url;

    }
    function hmwp_register_page_patch(){

        global $pagenow;

        if ( ( strtolower($pagenow) == 'wp-login.php') && isset( $_GET['action'] ) && ( strtolower( $_GET['action']) == 'register' ) ) {

            wp_redirect( home_url('/404/'));

            exit;

        }else if(!is_admin() && isset($_SERVER['REQUEST_URI']) && $_SERVER['REQUEST_URI'] != '' && basename($_SERVER['REQUEST_URI']) == 'register' ){

            $slug = basename($_SERVER['REQUEST_URI']);

            $page = get_page_by_path( $slug );

            if( empty($page) && $slug == 'register' ){

                wp_redirect(home_url('/404/'));

                exit;

            }

        }

    }
    function remove_ver_scripts($src)

    {

        if (strpos($src, 'ver='))

            $src = remove_query_arg('ver', $src);

        return $src;

    }
    function post_filter($content)

    {

        if ($this->post_replace_old)

            $content = str_replace($this->post_replace_old, $this->post_replace_new, $content);



        if ($this->post_preg_replace_old)

            $content = preg_replace($this->post_preg_replace_old, $this->post_preg_replace_new, $content);



        return $content;

    }	
    function add_key_login_to_url($url, $redirect = '0')

    {

        if ($this->opt('login_query'))

            $login_query = $this->opt('login_query');

        else

            $login_query = 'wps_options';



        if ($this->opt('admin_key'))

            $admin_key = $this->opt('admin_key');

        else

            $admin_key = '1234';



        if (trim($this->new_login_path, ' /') && trim($this->new_login_path, ' /') != 'wp-login.php')

            return str_replace('wp-login.php', trim($this->new_login_path, ' /'), $url);



        if ($url && $this->h->str_contains($url, 'wp-login.php') && !$this->h->str_contains($url, $login_query) && !$this->h->str_contains($url, $admin_key) && !$this->h->str_contains($url, 'ref_url'))

            return add_query_arg($login_query, $this->opt('admin_key'), $url);



        return $url;

    }
	
	public function hide_admin(){
		
		$this->block_access();		
	}
    function wp()

    {

        global $wp_query;



        //echo '<pre>'; print_r($wp_query); echo '</pre>';



        if ((is_feed() || is_comment_feed()) && !isset($_GET['feed']) && !$this->opt('feed_enable'))

            $this->block_access();

        //04-11-2019 Commented by dev. I dont know the exact reason add this code

        /*

        if (is_author() && !isset($_GET['author']) && !isset($_GET['author']) && !$this->opt('author_enable'))

            $this->block_access();

        if (is_search() && !isset($_GET['s']) && !$this->opt('search_enable'))

            $this->block_access();

        if (is_paged() && !isset($_GET['paged']) && !$this->opt('paginate_enable'))

            $this->block_access();

        if (is_page() && !isset($_GET['page_id']) && !isset($_GET['pagename']) && !$this->opt('page_enable'))

            $this->block_access();

        if (is_single() && !isset($_GET['p']) && !$this->opt('post_enable'))

            $this->block_access();

        if (is_category() && !isset($_GET['cat']) && !$this->opt('category_enable'))

            $this->block_access();

        if (is_tag() && !isset($_GET['tag']) && !$this->opt('tag_enable'))

            $this->block_access();

         * 

         */

        if ((is_date() || is_time()) && !isset($_GET['monthnum']) && !isset($_GET['m']) && !isset($_GET['w']) && !isset($_GET['second']) && !isset($_GET['year']) && !isset($_GET['day']) && !isset($_GET['hour']) && !isset($_GET['second']) && !isset($_GET['minute']) && !isset($_GET['calendar']) && $this->opt('disable_archive'))

            $this->block_access();



        if ((is_tax() || is_post_type_archive() || is_trackback() || is_attachment()) && !isset($_GET['post_type']) && !isset($_GET['taxonamy']) && !isset($_GET['attachment']) && !isset($_GET['attachment_id']) && !isset($_GET['preview']) && $this->opt('disable_other_wp'))

            $this->block_access();



        if (isset($_SERVER['HTTP_USER_AGENT']) && !is_404() && !is_home() && (stristr($_SERVER['HTTP_USER_AGENT'], 'BuiltWith') || stristr($_SERVER['HTTP_USER_AGENT'], '2ip.ru')))

            wp_redirect(home_url());



        if ($this->opt('remove_other_meta')) {

            if (function_exists('header_remove')) {

                header_remove('X-Powered-By'); // PHP 5.3+

                header_remove('WP-Super-Cache');

                header_remove('wp-super-cache');

                // exit;

            } else {

                // exit;

                header('X-Powered-By: ');

                header('WP-Super-Cache: ');

                header('wp-super-cache: ');

            }

        }

    }	
	
    function global_assets_filter()

    {

        global $wp_query;



        if ($this->opt('login_query'))

            $login_query = $this->opt('login_query');

        else

            $login_query = 'wps_options';



        $new_style_path = trim($this->opt('new_style_name'), ' /');



		do_action('before_global_assets_filter', $this, $login_query);



		//$this->h->ends_with($_SERVER["REQUEST_URI"], 'main.css') ||   <- For multisite

        if (isset($wp_query->query_vars['style_wrapper']) && $wp_query->query_vars['style_wrapper'] && $this->is_permalink()) {

            if ($this->full_hide && $this->opt('admin_key')) {

                if (!isset($_GET[$this->short_prefix . $login_query]) || $_GET[$this->short_prefix . $login_query] != $this->opt('admin_key'))

                    return false;



            }



            if (is_multisite() && isset($wp_query->query_vars['template_wrapper']))

                $css_file = str_replace(get_stylesheet(), $wp_query->query_vars['template_wrapper'], get_stylesheet_directory()) . '/style.css';

            else

                $css_file = get_stylesheet_directory() . '/style.css';



            status_header(200);

            //$expires = 60*60*24; // 1 day

            $days_to_expire = $this->opt('style_expiry_days');

            if(!is_numeric($days_to_expire) || $days_to_expire <= 0) {

                $days_to_expire = 3; //default

            }

            $expires = 60 * 60 * 24 * $days_to_expire; //3 day

            header("Pragma: public");

            header("Cache-Control: maxage=" . $expires);

            header('Expires: ' . gmdate('D, d M Y H:i:s', time() + $expires) . ' GMT');

            header('Content-type: text/css; charset=UTF-8');



            $css = file_get_contents($css_file);



            if ($this->opt('minify_new_style')) {

                if ($this->opt('minify_new_style') == 'quick') {

                    $to_remove = array('%\n\r%', '!/\*.*?\*/!s', '/\n\s*\n/', "%(\s){1,}%");

                    $css = preg_replace($to_remove, ' ', $css);

                } elseif ($this->opt('minify_new_style') == 'safe') {

                    require_once('lib/class.CSS-minify.php');

                    $css = Minify_CSS_Compressor::process($css, array());

                }



            }



            if ($this->opt('clean_new_style')) {

                if (strpos($css, 'alignright') === false) {  //Disable it if it uses import or so on

                    if (is_multisite()) {

                        $opts = get_blog_option(BLOG_ID_CURRENT_SITE, self::slug);

                        $opts['clean_new_style'] = '';

                        update_blog_option(BLOG_ID_CURRENT_SITE, self::slug, $opts);

                    } else {

                        $opts = get_option(self::slug);

                        $opts['clean_new_style'] = '';

                        update_option(self::slug, $opts);

                    }

                } else {

                    $old = array('wp-caption', 'alignright', 'alignleft', 'alignnone', 'aligncenter');

                    $new = array('x-caption', 'x-right', 'x-left', 'x-none', 'x-center');

                    $css = str_replace($old, $new, $css);

                }

                //We replace HTML, too

            }



            // if (is_child_theme())

            //     $css = str_replace('/thematic/', '/parent/', $css);



            echo $css;



            //  if(extension_loaded('zlib'))

            //     ob_end_flush();



            exit;

        }



        if ((isset($wp_query->query_vars['parent_wrapper']) && $wp_query->query_vars['parent_wrapper'] && $this->is_permalink())) {



            if ($this->full_hide && $this->opt('admin_key')) {

                if (!isset($_GET[$this->short_prefix . $login_query]) || $_GET[$this->short_prefix . $login_query] != $this->opt('admin_key'))

                    return false;

            }



            if (is_multisite() && isset($wp_query->query_vars['template_wrapper']))

                $css_file = str_replace(get_template(), $wp_query->query_vars['template_wrapper'], get_template_directory()) . '/style.css';

            else

                $css_file = get_template_directory() . '/style.css';





            status_header(200);

            //$expires = 60*60*24; // 1 day

            $expires = 60 * 60 * 24 * 3; //3 day

            header("Pragma: public");

            header("Cache-Control: maxage=" . $expires);

            header('Expires: ' . gmdate('D, d M Y H:i:s', time() + $expires) . ' GMT');

            header('Content-type: text/css; charset=UTF-8');



            $css = file_get_contents($css_file);



            if ($this->opt('minify_new_style')) {

                if ($this->opt('minify_new_style') == 'quick') {

                    $to_remove = array('%\n\r%', '!/\*.*?\*/!s', '/\n\s*\n/', "%(\s){1,}%");

                    $css = preg_replace($to_remove, ' ', $css);

                } elseif ($this->opt('minify_new_style') == 'safe') {

                    require_once('lib/class.CSS-minify.php');

                    $css = Minify_CSS_Compressor::process($css, array());

                }





            }



            if ($this->opt('clean_new_style')) {

                if (strpos($css, 'alignright') === false) {  //Disable it if it uses import or so on

                    if (is_multisite()) {

                        $opts = get_blog_option(BLOG_ID_CURRENT_SITE, self::slug);

                        $opts['clean_new_style'] = '';

                        update_blog_option(BLOG_ID_CURRENT_SITE, self::slug, $opts);

                    } else {

                        $opts = get_option(self::slug);

                        $opts['clean_new_style'] = '';

                        update_option(self::slug, $opts);

                    }

                } else {

                    $old = array('wp-caption', 'alignright', 'alignleft', 'alignnone', 'aligncenter');

                    $new = array('x-caption', 'x-right', 'x-left', 'x-none', 'x-center');

                    $css = str_replace($old, $new, $css);

                }

                //We replace HTML, too

            }



            // if (is_child_theme())

            //     $css = str_replace('/thematic/', '/parent/', $css);



            echo $css;



            //  if(extension_loaded('zlib'))

            //     ob_end_flush();



            exit;

        }





        if ((isset($wp_query->query_vars['style_internal_wrapper']) && $wp_query->query_vars['style_internal_wrapper'] && $this->is_permalink())) {



            if ($this->full_hide && $this->opt('admin_key')) {

                if (!isset($_GET[$this->short_prefix . $login_query]) || $_GET[$this->short_prefix . $login_query] != $this->opt('admin_key'))

                    return false;

            }



            status_header(200);

            //$expires = 60*60*24; // 1 day

            $expires = 60 * 60 * 24 * 10; //10 days

            header("Pragma: public");

            header("Cache-Control: maxage=" . $expires);

            header('Expires: ' . gmdate('D, d M Y H:i:s', time() + $expires) . ' GMT');

            header('Content-type: text/css; charset=UTF-8');



            $blog_id = get_current_blog_id();

            if (!is_multisite())

                $old = get_option('hmwp_internal_assets');

            else

                $old = get_blog_option($blog_id, 'hmwp_internal_assets');



            if (is_array($old))

                echo $old['css'] . "\n\n\n";



            echo $this->auto_config_internal_css;

            echo $this->opt('internal_css');



            //  if(extension_loaded('zlib'))

            //     ob_end_flush();

            exit;

        }





        if ((isset($wp_query->query_vars['script_internal_wrapper']) && $wp_query->query_vars['script_internal_wrapper'] && $this->is_permalink())) {



            if ($this->full_hide && $this->opt('admin_key')) {

                if (!isset($_GET[$this->short_prefix . $login_query]) || $_GET[$this->short_prefix . $login_query] != $this->opt('admin_key'))

                    return false;

            }



            status_header(200);

            //$expires = 60*60*24; // 1 day

            $expires = 60 * 60 * 24 * 10; //10 day

            header("Pragma: public");

            header("Cache-Control: maxage=" . $expires);

            header('Expires: ' . gmdate('D, d M Y H:i:s', time() + $expires) . ' GMT');

            header('Content-type: application/javascript; charset=UTF-8');



            $blog_id = get_current_blog_id();

            if (!is_multisite())

                $old = get_option('hmwp_internal_assets');

            else

                $old = get_blog_option($blog_id, 'hmwp_internal_assets');



            if (is_array($old))

                echo $old['js'] . "\n\n\n";



            //todo: avoid duplicate with auto_internal

            echo $this->auto_config_internal_js;

            echo $this->opt('internal_js');



            //  if(extension_loaded('zlib'))

            //     ob_end_flush();

            exit;

        }





        if ((isset($wp_query->query_vars['get_wrapper']) && $wp_query->query_vars['get_wrapper'] && $this->is_permalink() && isset($_GET['_case']) && isset($_GET['_addr']))) {

//RewriteRule ^_get/([A-Za-z0-9-_\.]+)/(.*) /wp39/index.php?get_wrapper=1&_case=$1&_addr=$2&AK_wps_options=1234 [QSA,L]



            if ($this->full_hide && $this->opt('admin_key')) {

                if (!isset($_GET[$this->short_prefix . $login_query]) || $_GET[$this->short_prefix . $login_query] != $this->opt('admin_key'))

                    return false;

            }



            $host = $url = '';

            $data = array();

            $cache = true;



            switch ($_GET['_case']) {



                case 'ws0':

                    $host = 'https://s0.wp.com/'; //add /

                    $cache = false;

                    break;

                case 'ws0i':

                    $host = 'https://s0.wp.com/i/'; //add /

                    $cache = true;

                    break;

                case 'stats':

                    $host = 'http://stats.wp.com/';

                    $cache = false;

                    break;

                case 'ws0js':

                    $host = 'http://s0.wp.com/wp-content/js/';

                    if ($_GET['_addr'] == 'devicepx-jetpack.js')

                        $_GET['_addr'] = 'devicepx.js';

                    $cache = true;

                    break;

                default:

                    $host = 'Invalid';

                    $cache = false;

                    break;

            }





            $url = $host . $_GET['_addr'];



            //echo $url;

            $cache_name = hash('crc32', $_GET['_case'] . $_GET['_addr']);



            if ($cache)

                $data = get_transient($cache_name);



            if (!$data) {

                $data = @wp_remote_get($url, 'reject_unsafe_urls=true&sslverify=true&user-agent=Mozilla/5.0 (Windows NT 6.1; WOW64; rv:18.0) Gecko/20100101 Firefox/18.0&limit_response_size=' . 3 * 1024 * 1024); //3mb

                if ($cache && is_array($data))

                    set_transient($cache_name, $data, 10 * DAY_IN_SECONDS);

            }



            //print_r($data);

            if (!is_wp_error($data) && $data['body']) {



                // print_r($data['headers']->getAll());



                status_header($data['response']['code']);



                //$expires = 60 * 60 * 24 * 10; //10 days

                if ($data['headers']->offsetGet('content-type'))

                    header('Content-Type: ' . $data['headers']->offsetGet('content-type'));



                if (is_array($data['headers']->offsetGet('cache-control'))) {

                    foreach ($data['headers']->offsetGet('cache-control') as $control)

                        header("Cache-Control: " . $control);

                } else {

                    header("Cache-Control: " . $data['headers']->offsetGet('cache-control'));

                }



                if ($data['headers']->offsetGet('pragma'))

                    header('Pragma: ' . $data['headers']->offsetGet('pragma'));



                if ($data['headers']->offsetGet('expires'))

                    header('Expires: ' . $data['headers']->offsetGet('expires'));



                echo $data['body'];

            } else {

                status_header('400');

                echo 'Wrapping Error';

            }

            exit;

        }



		do_action('after_global_assets_filter', $this, $login_query);

    }

    function custom_404_page($templates)

    {

        global $current_user;

        $visitor = esc_attr((is_user_logged_in()) ? $current_user->user_login : $_SERVER["REMOTE_ADDR"]);



        if (is_multisite())

            $permalink = get_blog_permalink(BLOG_ID_CURRENT_SITE, $this->opt('custom_404_page'));

        else

            $permalink = get_permalink($this->opt('custom_404_page'));

        //$permalink = home_url('?'.$this->opt('page_query').'='.$this->opt('custom_404_page'));

        if ($this->opt('custom_404') && $this->opt('custom_404_page'))

            wp_redirect(add_query_arg(array('by_user' => $visitor, 'ref_url' => urldecode($_SERVER["REQUEST_URI"])), $permalink));

        else

            return $templates;



        die();



    }

    function styles_scripts()

    {

        $site = '';

        if (is_multisite() && !$this->is_subdir_mu)

            $site = '&sn=' . $this->blog_path;



        if ($this->add_auto_internal('css') && $this->is_permalink()) {

            $page = $this->hash($_SERVER['REQUEST_URI']);

            //todo:

            if ($this->opt('auto_internal') == 1 || $this->opt('auto_internal') == 3)

                $page = $this->hash($_SERVER['REQUEST_URI']);



            wp_enqueue_style('auto_css', network_home_url('/_auto.css') . '?_req=' . $page . $site, array(), false);

        }



        if ($this->add_auto_internal('js') && $this->is_permalink()) {

            //can not use $site here because woocommerce need req

            $page = urlencode(base64_encode($_SERVER['REQUEST_URI']));



            //require for woocommerce endpoint issue

            if ($this->auto_config_plugins || $this->opt('auto_internal') >= 2)

                $page = urlencode(base64_encode($_SERVER['REQUEST_URI']));



            wp_enqueue_script('auto_js', network_home_url('/_auto.js') . '?_req=' . $page . $site, array(), false);

        }

    }

    function front_css_js(){        

        if($this->opt('replace_wpnonce') == 'on'){ ?>

            <script type="text/javascript">

                jQuery(document).ajaxSuccess(function (event, xhr, settings) {

                    var content = xhr.responseText;

                    if(content.indexOf('data') != -1){

                        var new_js = jQuery.parseJSON(content);

                        if( jQuery('#activity-stream').length > 0 ){

                            var get_content = new_js.data['contents'];

                            var get_content_n = HMWPReplaceMethod(get_content,"wpnonce=","nonce=");

                            jQuery('#activity-stream').replaceWith(get_content_n);

                        }

                    }

                });

                function HMWPReplaceMethod(str,find,replace_with){

                    while (str.indexOf(find) !== -1 ){

                        from = str.indexOf(find);

                        to = from + find.length;

                        str = str.substr(0,from)+replace_with+str.substr(to, str.length-to);

                    }

                    return str;

                }

            </script>

        <?php        

        }        

    }	
    function admin_notices()

    {

        global $current_user;

        if (is_super_admin()) {

			$this->h->update_pp_important_messages();

		}



        $options_file = (is_multisite()) ? 'network/settings.php' : 'admin.php';

        $page_url = admin_url(add_query_arg('page', self::slug, $options_file));

        $show_access_message = true;



        //Update hmw_all_plugins list whenever a theme or plugin activate

        if ((isset($_GET['page']) && ($_GET['page'] == self::slug)) || isset($_GET['deactivate']) || isset($_GET['activate']) || isset($_GET['activated']) || isset($_GET['activate-multi'])) {

            update_option('hmw_all_plugins', array_keys(get_plugins()));



            $blog_id = get_current_blog_id();

            if (!is_multisite())

                delete_option('hmwp_internal_assets');

            else

                delete_blog_option($blog_id, 'hmwp_internal_assets');

        }



        if (isset($_GET['page']) && $_GET['page'] == self::slug && function_exists('bulletproof_security_load_plugin_textdomain')) {

            echo __('<div class="error"><p>You use BulletProof security plugin. To make it work correctly you need to configure Hide My WP manually. <a target="_blank" href="' . add_query_arg(array('die_message' => 'single')) . '" class="button">' . __('Manual Configuration', self::slug) . '</a>. (If you already did that ignore this message).', self::slug) . '</p></div>';

            $show_access_message = false;

        }



        if (isset($_GET['page']) && $_GET['page'] == self::slug && isset($_GET['new_admin_action']) && $_GET['new_admin_action'] == 'configured') {



            if (is_multisite()) {

                $opts = (array)get_blog_option(BLOG_ID_CURRENT_SITE, self::slug);

                $opts['new_admin_path'] = get_option('hmwp_temp_admin_path');

                update_blog_option(BLOG_ID_CURRENT_SITE, self::slug, $opts);

            } else {

                $opts = (array)get_option(self::slug);

                $opts['new_admin_path'] = get_option('hmwp_temp_admin_path');

                update_option(self::slug, $opts);

            }

            delete_option('hmwp_temp_admin_path');

            wp_redirect(add_query_arg('new_admin_action', 'redirect_to_new', $page_url));

        }



        if (isset($_GET['page']) && $_GET['page'] == self::slug && isset($_GET['new_admin_action']) && $_GET['new_admin_action'] == 'redirect_to_new') {

            //wp_logout();

            wp_redirect(wp_login_url('', true)); //true means force auth

        }



        if (isset($_GET['page']) && $_GET['page'] == self::slug && isset($_GET['new_admin_action']) && $_GET['new_admin_action'] == "abort") {

            ///update_option('hmwp_temp_admin_path', $this->opt('new_admin_path'));

            delete_option('hmwp_temp_admin_path');

            wp_redirect(add_query_arg('new_admin_action', 'aborted_msg', $page_url));

        }



        if (isset($_GET['page']) && $_GET['page'] == self::slug && isset($_GET['new_admin_action']) && $_GET['new_admin_action'] == "aborted_msg") {

            echo '<div class="error"><p>Change of admin path is cancelled!</p></div>';

        }

        $permalink_structure = get_option( 'permalink_structure' );

        $permalink_structurel_link = admin_url('/options-permalink.php');

        if(empty($permalink_structure))

        {

            echo '<div class="error"><p>For HMWP to work correctly, the site\'s Permalink Structure has to be custom one and NOT the Plain. Please change it from <a href='.$permalink_structurel_link.'>here</a>.!</p></div>';

        }



        if (trim(get_option('hmwp_temp_admin_path'), ' /'))

            $new_admin_path = trim(get_option('hmwp_temp_admin_path'), ' /');

        elseif (trim($this->opt('new_admin_path'), '/ '))

            $new_admin_path = trim($this->opt('new_admin_path'), '/ ');

        else

            $new_admin_path = 'wp-admin';





        if ($this->admin_current_cookie() != $new_admin_path && is_super_admin()) {

            if (!isset($_GET['new_admin_action']) && !isset($_GET['die_message'])) {

                $page_url = str_replace($this->admin_current_cookie(), 'wp-admin', $page_url);



                if ($new_admin_path == 'wp-admin')

                    wp_redirect(add_query_arg(array('die_message' => 'revert_admin'), $page_url));

                else {

                    $rand_token = uniqid('token', true);

                    update_option('hmwp_reset_token', $rand_token);

                    wp_redirect(add_query_arg(array('die_message' => 'new_admin'), $page_url));

                }



            }



        }

        //Good place to flush! We really need this.

        if (is_super_admin() && !function_exists('bulletproof_security_load_plugin_textdomain') && !$this->opt('customized_htaccess'))

            flush_rewrite_rules(true);



        if (is_multisite() && is_network_admin()) {

            global $wpdb;

            $sites = $wpdb->get_results("SELECT blog_id, domain FROM {$wpdb->blogs} WHERE archived = '0' AND spam = '0' AND deleted = '0' ORDER BY blog_id");



            //Loop through them

            foreach ($sites as $site) {

                global $wp_rewrite;

                //switch_to_blog($site->blog_id);

                delete_blog_option($site->blog_id, 'rewrite_rules');

                //$wp_rewrite->init();

                //$wp_rewrite->flush_rules();

            }



        }



        $home_path = get_home_path();

        if ((!file_exists($home_path . '.htaccess') && is_writable($home_path)) || is_writable($home_path . '.htaccess')) {

			$writable = true;

		} else {

			$writable = false;

		}



		if (!$this->is_permalink()) {

			if (isset($_GET['page']) && $_GET['page'] == 'hmwp_setup_wizard') {

				echo '<div class="error"><p>' . __('Your <a href="options-permalink.php">permalink structure</a> is off. Once you finish setup, We will change permalink in order to work all features.', self::slug) . '</p></div>';

			}

			if (isset($_GET['page']) && $_GET['page'] == self::slug) {

				if (is_multisite()) {

					echo '<div class="error"><p>' . __('Please enable WP permalink structure (Settings -> Permalink ) in your sites.', self::slug) . '</p></div>';

				} else {

					echo '<div class="error"><p>' . __('Your <a href="options-permalink.php">permalink structure</a> is off. In order to get all features of this plugin please enable it.', self::slug) . '</p></div>';

				}

			}

			$show_access_message = false;

		}

		



		if (isset($_GET['page']) && $_GET['page'] == self::slug && (isset($_GET['settings-updated']) || isset($_GET['settings-imported'])) && is_multisite()) {

            echo '<div class="error"><p>' . __('You have enabled Multisite. It\'s require to (re)configure Hide My WP after changing settings or activating new plugin or theme. <br><br><a target="_blank" href="' . add_query_arg(array('die_message' => 'multisite')) . '" class="button">' . __('Multisite Configuration', self::slug) . '</a>', self::slug) . '</p></div>';

            $show_access_message = false;

        }



        $nginx = false;

        if (isset($_GET['page']) && $_GET['page'] == self::slug && (stristr($_SERVER['SERVER_SOFTWARE'], 'nginx') || stristr($_SERVER['SERVER_SOFTWARE'], 'wpengine'))) {

            echo '<div class="error"><p>' . __('You use Nginx web server. It\'s require to (re)configure Hide My WP  after changing settings or activating new plugin or theme. <br><br><a target="_blank" href="' . add_query_arg(array('die_message' => 'nginx')) . '" class="button">' . __('Nginx Configuration', self::slug) . '</a>', self::slug) . '</p></div>';

            $show_access_message = false;

            $nginx = true;

        }



        $win = false;

        if (isset($_GET['page']) && $_GET['page'] == self::slug && stristr($_SERVER['SERVER_SOFTWARE'], 'iis') || stristr($_SERVER['SERVER_SOFTWARE'], 'Windows')) {

            echo '<div class="error"><p>' . __('You use Windows (IIS) web server. It\'s require to (re)configure Hide My WP after changing settings or activating new plugin or theme. <br><br><a target="_blank" href="' . add_query_arg(array('die_message' => 'iis')) . '" class="button">' . __('IIS Configuration', self::slug) . '</a>', self::slug) . '</p></div>';

            $show_access_message = false;

            $win = true;

        }





        if (isset($_GET['page']) && $_GET['page'] == self::slug && isset($_GET['undo_config']) && $_GET['undo_config'])

            echo '<div class="updated fade"><p>' . __('Previous settings have been restored!', self::slug) . '</p></div>';



        if (isset($_GET['page']) && $_GET['page'] == self::slug && !$writable && !$nginx && !$win && !function_exists('bulletproof_security_load_plugin_textdomain')) {

            echo '<div class="error"><p>' . __('It seems there is no writable htaccess file in your WP directory. If you use Apache (and not Nginx or IIS) please change permission of .htaccess file.', self::slug) . '</p></div>';

            $show_access_message = false;

        }



        if (basename($_SERVER['PHP_SELF']) == 'options-permalink.php' && $this->is_permalink() && isset($_POST['permalink_structure'])) {

			echo '<div class="updated"><p>' . sprintf(__('We are refreshing this page in order to implement changes. %s', self::slug), '<a href="options-permalink.php">Manual Refresh</a>') . '<script type="text/JavaScript"><!--  setTimeout("window.location = \'options-permalink.php\';", 5000);   --></script></p> </div>';

		}



		/*if (isset($_GET['page']) && $_GET['page'] == self::slug && (isset($_GET['settings-updated']) || isset($_GET['settings-imported'])) && $show_access_message && !$this->access_test()) {

			echo '<div class="error"><p>' . __('HMWP guesses it broke your site. If it didn\'t ignore this messsage otherwise read <a href="http://codecanyon.net/item/hide-my-wp-no-one-can-know-you-use-wordpress/4177158/faqs/18136" target="_blank"><strong>this FAQ</strong></a> or revert settings to default.', self::slug) . '</p></div>';

		}*/



		if (!defined('AUTH_KEY') || !defined('SECURE_AUTH_KEY') || !defined('LOGGED_IN_KEY') || !defined('NONCE_KEY') || !defined('AUTH_SALT') || !defined('SECURE_AUTH_SALT') || !defined('LOGGED_IN_SALT') || !defined('LOGGED_IN_SALT') || !defined('NONCE_SALT') || NONCE_SALT == 'put your unique phrase here' || !NONCE_SALT || AUTH_KEY == 'put your unique phrase here' || !AUTH_KEY || NONCE_KEY == 'put your unique phrase here') {

			echo '<div class="error"><p>' . __('WP Secure Security Check: Your site is at risk. WP installed wrongly: one or more of security keys are invalid. <a href="https://codex.wordpress.org/Editing_wp-config.php#Security_Keys" target="_blank"><strong>Read here</strong></a> for details.', self::slug) . '</p></div>';

		}



		if (isset($_GET['page']) && $_GET['page'] == self::slug && (isset($_GET['settings-updated']) || isset($_GET['settings-imported'])) && (WP_CACHE || function_exists('hyper_cache_sanitize_uri') || class_exists('WpFastestCache') || defined('QUICK_CACHE_ENABLE') || defined('CACHIFY_FILE') || defined('WP_ROCKET_VERSION'))) {

			echo '<div class="updated"><p>' . __('It seems you use a caching plugin alongside Hide My WP. Good, just please make sure to flush it to see changes! (consider browser cache, too!)', self::slug) . '</p></div>';

		}

	}	
    function admin_current_cookie()

    {

        if (SITECOOKIEPATH)

            $current_cookie = str_replace(SITECOOKIEPATH, '', ADMIN_COOKIE_PATH);



        //For non-sudomain and with pathes mu:

        if (!$current_cookie)

            $current_cookie = 'wp-admin';



        return $current_cookie;

    }
	
    function mod_rewrite_rules($rules)

    {

        $home_root = parse_url(home_url());



        if (isset($home_root['path']))

            $home_root = trailingslashit($home_root['path']);

        else

            $home_root = '/';



        if ($this->opt('avoid_direct_access'))

            $rules = str_replace('(.*) ' . $home_root . '$1$2', '(.*) $1$2', $rules);



        if ($this->full_hide && $this->opt('admin_key')) {

            $slashed_home = trailingslashit(get_option('home'));

            $base = parse_url($slashed_home, PHP_URL_PATH);



            if (!$this->sub_folder && $base && $base != '/')

                $sub_install = trim($base, ' /') . '/';

            else

                $sub_install = '';



            $trust_key = str_replace('?', '', $this->trust_key); //remove ?



            // $this->sub_folder;

            $new_rules = "RewriteRule ^index\\.php$ - [L]" . PHP_EOL

				. "RewriteCond %{HTTP_COOKIE} !" . $this->access_cookie() . "=1" . PHP_EOL

				. "RewriteCond %{QUERY_STRING} !" . str_replace('?', '', $this->trust_key) . PHP_EOL

				. "RewriteRule ^((wp-content|wp-includes|wp-admin)/(.*)) /" . $sub_install . "nothing_404_404" . $this->trust_key . " [QSA,L]";

			$rules = str_replace('RewriteRule ^index\\.php$ - [L]', $new_rules, $rules);

        }

        //Add online detection rule

        if ($this->opt('hide_online_detectors')) {

            //$rules .= 'RewriteCond %{HTTP_USER_AGENT} WhatCMS [NC]' . "\n" . 'RewriteRule .* - [F,L]' . "\n";

			$detection_sites = array(

				'RewriteCond %{HTTP_REFERER} whatcms\. [NC]',

				'RewriteCond %{HTTP_REFERER} wpthemedetector\. [NC]',

				'RewriteCond %{HTTP_REFERER} wpdetector\. [NC]',

				'RewriteCond %{HTTP_REFERER} builtwith\. [NC]',

				'RewriteCond %{HTTP_REFERER} wappalyzer\. [NC]',

				'RewriteCond %{HTTP_REFERER} isitwp\. [NC]',

				'RewriteCond %{HTTP_USER_AGENT} whatcms [NC]',

				'RewriteRule .* - [F,L]',

			);

			$detection_rules = "<IfModule mod_rewrite.c>" . PHP_EOL;

			$detection_rules .= implode("\n", $detection_sites) . PHP_EOL;

			$detection_rules .= "</IfModule>";

			$rules .= $detection_rules;

		}

        $rules = $this->cleanup_config($rules);



        return $rules;

    }

    function cleanup_config($config)

    {

        $config = str_replace('//', '/', $config);

        if (defined('WP_SITEURL'))

            $config = str_replace(WP_SITEURL, '', $config);



        if (defined('WP_HOME'))

            $config = str_replace(WP_HOME, '', $config);



        return str_replace(array(site_url(), home_url()), '', $config);

    }
    function access_cookie()

    {

        return preg_replace("/[^a-zA-Z]/", "", substr(SECURE_AUTH_SALT, 2, 8));

    }	
    function hash($key)

    {

        return hash('crc32', preg_replace("/[^a-zA-Z]/", "", substr(NONCE_KEY, 2, 6)) . $key);

    }

    function ob_starter()

    {

        ob_start(array(&$this, "global_html_filter"));

        //echo ob_get_level();

        if (class_exists('WooCommerce'))

            ob_start(); //Fix some WooCommerce themes bug

    }	
    function is_permalink()

    {

        global $wp_rewrite;

        if (!isset($wp_rewrite) || !is_object($wp_rewrite) || !$wp_rewrite->using_permalinks())

            return false;

        return true;

    }

    function nginx_config()

    {

        $new_theme_path = trim($this->opt('new_theme_path'), '/ ');

        $new_plugin_path = trim($this->opt('new_plugin_path'), '/ ');

        $new_upload_path = trim($this->opt('new_upload_path'), '/ ');

        $new_include_path = trim($this->opt('new_include_path'), '/ ');

        $new_style_name = trim($this->opt('new_style_name'), '/ ');

        $new_content_path = trim($this->opt('new_content_path'), '/ ');



        if (trim(get_option('hmwp_temp_admin_path'), ' /'))

            $new_admin_path = trim(get_option('hmwp_temp_admin_path'), ' /');

        else

            $new_admin_path = trim($this->opt('new_admin_path'), '/ ');



        $rel_login_path = $this->sub_folder . '/wp-login.php';

        $new_login_path = str_replace('.', '\.', trim($this->opt('new_login_path'), '/ '));



        if (is_multisite()) {

            if ($this->is_subdir_mu)

                $new_login_path = '/' . $new_login_path;

            $rel_login_path = $this->blog_path . str_replace($this->sub_folder, '', $new_login_path);

        }



        $replace_admin_ajax = trim($this->opt('replace_admin_ajax'), '/ ');

        $replace_admin_ajax_rule = str_replace('.', '\\.', $replace_admin_ajax);

        $replace_comments_post = trim($this->opt('replace_comments_post'), '/ ');

        $replace_comments_post_rule = str_replace('.', '\\.', $replace_comments_post);



        $upload_path = wp_upload_dir();



        //not required for nginx

        $sub_install = '';



        if (is_ssl())

            $upload_path['baseurl'] = str_replace('http:', 'https:', $upload_path['baseurl']);



        $rel_upload_path = $this->sub_folder . trim(str_replace(site_url(), '', $upload_path['baseurl']), '/');

        $rel_include_path = $this->sub_folder . trim(WPINC);

        $rel_plugin_path = $this->sub_folder . trim(str_replace(site_url(), '', WP_SECURE_PLUGIN_URL), '/');

        $rel_theme_path = $this->sub_folder . trim(str_replace(site_url(), '', get_stylesheet_directory_uri()), '/');

        $rel_comments_post = $this->sub_folder . 'wp-comments-post.php';

        $rel_admin_ajax = $this->sub_folder . 'wp-admin/admin-ajax.php';





        $rel_content_path = $this->sub_folder . trim(str_replace(site_url(), '', WPS_CONTENT_URL), '/');

        $rel_theme_path_no_template = str_replace('/' . get_stylesheet(), '', $rel_theme_path);



        $style_path_reg = '';

        //if ($this->opt('new_style_name') && $this->opt('new_style_name') != 'style.css' && !isset($_POST['wp_customize']))

        //    $style_path_reg = '|'.$rel_theme_path.'/style\.css';



        //|'.$rel_plugin_path.'/index\.php|'.$rel_theme_path_no_template.'/index\.php'





        $hide_other_file_rule = $this->sub_folder . 'readme\.html|' . $this->sub_folder . 'license\.txt|' . $rel_content_path . '/debug\.log' . $style_path_reg . '|' . $rel_include_path . '/$';



        $disable_directoy_listing = '(((' . $rel_content_path . '|' . $rel_include_path . ')/([A-Za-z0-9\-\_\/]*))|(wp-admin/(!network\/?)([A-Za-z0-9\-\_\/]+)))(\.txt|/)$';



        if ($this->opt('login_query') && $this->opt('login_query'))

            $login_query = $this->opt('login_query');

        else

            $login_query = 'wps_options';



        if ($this->opt('antispam') && $this->opt('admin_key'))

            $antispam = '?' . $login_query . '=' . $this->opt('admin_key');

        else

            $antispam = '';



        if ($this->opt('avoid_direct_access')) {



            $rel_theme_path_with_theme = $this->sub_folder . trim(str_replace(site_url(), '', get_stylesheet_directory_uri()), '/');



            $white_list = explode(",", $this->opt('direct_access_except'));

            $white_list[] = 'wp-login.php';

            $white_list[] = 'index.php';

            $white_list[] = 'wp-admin/';



            if (get_option('hmwp_reset_token')) {

                $reset_url = $rel_plugin_path. '/' .dirname(HMW_FILE) . '/d.php';

                $white_list[] = $reset_url;

            }



            if ($this->opt('new_login_path'))

                $white_list[] = $this->opt('new_login_path');



            if ($this->opt('exclude_theme_access'))

                $white_list[] = $rel_theme_path_with_theme . '/';

            if ($this->opt('exclude_plugins_access'))

                $white_list[] = $rel_plugin_path . '/';



            $block = true;

            $white_regex = '';

            foreach ($white_list as $white_file) {

                $white_regex .= $this->sub_folder . str_replace(array('.', ' '), array('\.', ''), $white_file) . '|';  //make \. remove spaces

            }

            $white_regex = substr($white_regex, 0, strlen($white_regex) - 1); //remove last |

            $white_regex = str_replace(array("\r", "\r\n", "\n"), '', $white_regex);

        }





        $output = '';



        if ($this->full_hide) {

            //ignored: condition 0

            //todo: wp-content|includes

            $full_hide = '

if ($args !~ "' . str_replace('?', '', $this->trust_key) . '"){

	set $rule_0 1;

}

if ($http_cookie !~* "' . $this->access_cookie() . '=1"){

	set $rule_0 "${rule_0}2";

}

if ($rule_0 = "12"){

	rewrite ^/((wp-content|wp-includes|wp-admin)/(.*)) /nothing_404_404' . $this->trust_key . ' last;

}

';



            $output = $full_hide . $output;

        }



        if ($this->opt('replace_urls') || $this->auto_replace_urls) {

            $replace_urls = $this->h->replace_newline(trim($this->opt('replace_urls'), ' '), '|%|');

            $replace_lines = explode('|%|', $replace_urls);

            $replace_lines = array_merge($replace_lines, $this->auto_replace_urls);

            if ($replace_lines) {

                foreach ($replace_lines as $line) {



                    $replace_word = explode('==', $line);

                    if (isset($replace_word[0]) && isset($replace_word[1])) {



                        //Check whether last character is / or not to recgnize folders

                        $is_folder = false;

                        if (substr($replace_word[0], strlen($replace_word[0]) - 1, strlen($replace_word[0])) == '/')

                            $is_folder = true;



                        $replace_word[0] = trim($replace_word[0], '/ ');

                        $replace_word[1] = trim($replace_word[1], '/ ');



                        $is_block = false;

                        if ($replace_word[1] == 'nothing_404_404')

                            $is_block = true;





                        if ($is_block) {

                            //Swap words to make theme unavailable

                            $temp = $replace_word[0];

                            $replace_word[0] = $replace_word[1];

                            $replace_word[1] = $temp;

                        }



                        $replace_word[0] = str_replace(array('amp;', '%2F', '//', '.'), array('', '/', '/', '.'), $replace_word[0]);

                        $replace_word[1] = str_replace(array('.', 'amp;'), array('\.', ''), $replace_word[1]);



                        if ($is_folder) {

                            $output .= 'rewrite ^/' . $replace_word[1] . '/(.*) /' . $sub_install . $replace_word[0] . '/$1' . $this->trust_key . ' last;' . "\n";

                        } else {

                            $output .= 'rewrite ^/' . $replace_word[1] . ' /' . $sub_install . $replace_word[0] . $this->trust_key . ' last;' . "\n";

                        }

                    }

                }

            }

        }





        if (is_multisite()) {

            $sitewide_plugins = array_keys((array)get_site_option('active_sitewide_plugins', array()));

            $active_plugins = array_merge((array)get_blog_option(BLOG_ID_CURRENT_SITE, 'active_plugins'), $sitewide_plugins);

        } else {

            $active_plugins = get_option('active_plugins');

        }



        if ($this->opt('rename_plugins') == 'all')

            $active_plugins = get_option('hmw_all_plugins');



        $pre_plugin_path = '';

        if ($this->opt('rename_plugins') && $new_plugin_path) {

            foreach ((array)$active_plugins as $active_plugin) {



                //Ignore itself or a plugin without folder

                if (!$this->h->str_contains($active_plugin, '/') || $active_plugin == self::main_file || strpos($active_plugin, 'elementor') !== FALSE)

                    continue;



                $new_plugin_path = trim($new_plugin_path, '/ ');



                $codename_this_plugin = $this->hash($active_plugin);



                $rel_this_plugin_path = trim(str_replace(site_url(), '', plugin_dir_url($active_plugin)), '/');

                //Allows space in plugin folder name

                $rel_this_plugin_path = $this->sub_folder . str_replace(' ', '\ ', $rel_this_plugin_path);



                $new_this_plugin_path = $new_plugin_path . '/' . $codename_this_plugin;

                $pre_plugin_path .= 'rewrite ^/' . $new_this_plugin_path . '/(.*) /' . $rel_this_plugin_path . '/$1' . $this->trust_key . ' last;' . "\n";

            }

        }





        if (is_child_theme()) {

            //remove the end folder of so we can replace it with parent theme

            $path_array = explode('/', $new_theme_path);

            array_pop($path_array);

            $path_string = implode('/', $path_array);



            if ($path_string)

                $path_string = $path_string . '/';



            $parent_theme_new_path = $path_string . get_template();

            $rel_parent_theme_path = $this->sub_folder . trim(str_replace(site_url(), '', get_template_directory_uri()), '/');

            $output .= 'rewrite ^/' . $parent_theme_new_path . '/(.*) /' . $rel_parent_theme_path . '/$1' . $this->trust_key . ' last;' . "\n";

            $parent_theme_new_path_with_main = $new_theme_path . '_main';



            $output .= 'rewrite ^/' . $parent_theme_new_path_with_main . '/style\.css' . ' /?parent_wrapper=1' . str_replace('?', '&', $this->trust_key) . ' last;' . "\n";



            $output .= 'rewrite ^/' . $parent_theme_new_path_with_main . '/(.*) /' . $rel_parent_theme_path . '/$1' . $this->trust_key . ' last;' . "\n";

        }





        if ($new_admin_path && $new_admin_path != 'wp-admin')

            $output .= 'rewrite ^/' . $new_admin_path . '/(.*) /' . $this->sub_folder . 'wp-admin/$1' . $this->trust_key . ' last;' . "\n";



        if ($new_login_path && $new_login_path != 'wp-login.php')

            $output .= 'rewrite ^/' . $new_login_path . ' /' . $this->sub_folder . $rel_login_path . $this->trust_key . ' last;' . "\n";



        if ($new_include_path)

            $output .= 'rewrite ^/' . $new_include_path . '/(.*) /' . $rel_include_path . '/$1' . $this->trust_key . ' last;' . "\n";



        if ($new_upload_path)

            $output .= 'rewrite ^/' . $new_upload_path . '/(.*) /' . $rel_upload_path . '/$1' . $this->trust_key . ' last;' . "\n";



        if ($new_plugin_path && $pre_plugin_path)

            $output .= $pre_plugin_path;



        if ($new_plugin_path)

            $output .= 'rewrite ^/' . $new_plugin_path . '/(.*) /' . $rel_plugin_path . '/$1' . $this->trust_key . ' last;' . "\n";



        if ($new_style_name)

            $output .= 'rewrite ^/' . $new_theme_path . '/' . str_replace('.', '\.', $new_style_name) . ' /?style_wrapper=1' . str_replace('?', '&', $this->trust_key) . ' last;' . "\n";



        if ($this->add_auto_internal('css'))

            $output .= 'rewrite ^/_auto\.css' . ' /?style_internal_wrapper=1' . str_replace('?', '&', $this->trust_key) . ' last;' . "\n";



        if ($this->add_get_wrapper())

            $output .= 'rewrite ^/_get/([A-Za-z0-9-_\.]+)/(.*)' . ' /?get_wrapper=1&_case=$1&_addr=$2' . str_replace('?', '&', $this->trust_key) . ' last;' . "\n";

        //RewriteRule ^_get/([A-Za-z0-9-_\.]+)/(.*) /wp39/index.php?get_wrapper=1&_case=$1&_addr=$2&AK_wps_options=1234 [QSA,L]





        if (trim($this->opt('new_style_name'), ' /') && trim($this->opt('new_style_name'), ' /') != 'style.css') {

            $old_style = $new_theme_path . '/' . 'style\.css';

            $output .= 'rewrite ^/' . $old_style . ' /nothing_404_404' . $this->trust_key . ' last;' . "\n";

        }



        if ($new_theme_path)

            $output .= 'rewrite ^/' . $new_theme_path . '/(.*) /' . $rel_theme_path . '/$1' . $this->trust_key . ' last;' . "\n";



        if ($replace_comments_post && $replace_comments_post != 'wp-comments-post.php')

            $output .= 'rewrite ^/' . $replace_comments_post_rule . ' /' . $rel_comments_post . $this->trust_key . ' last;' . "\n";



        if ($replace_admin_ajax_rule && $replace_admin_ajax_rule != 'wp-admin/admin-ajax.php')

            $output .= 'rewrite ^/' . $replace_admin_ajax_rule . ' /' . $rel_admin_ajax . $this->trust_key . ' last;' . "\n";



        if ($new_content_path)

            $output .= 'rewrite ^/' . $new_content_path . '/(.*) /' . $rel_content_path . '/$1' . $this->trust_key . ' last;' . "\n";





        if ($this->hide_other_files)

            $output .= 'rewrite ^/(' . $hide_other_file_rule . ') /nothing_404_404' . $this->trust_key . ' last;' . "\n";



        if ($this->disable_directory_listing)

            $output .= 'rewrite ^/' . $disable_directoy_listing . ' /nothing_404_404' . $this->trust_key . ' last;' . "\n";



        if ($this->opt('avoid_direct_access')) {



            $output .= "\n" . '#If you have a block with "location ~ \.php$"  add following two lines to the top of that block otherwise leave it unchanged' . "\n";

            $output .= 'rewrite ^/(' . $white_regex . ')(.*)' . ' /$1$2' . $this->trust_key . ' break;' . "\n";

            $output .= 'rewrite ^/(.*)\.php(.*)' . ' /nothing_404_404' . $this->trust_key . ' last;' . "\n\n";

        }





        if ($output)

            //$output='if (!-e $request_filename) {'. "\n" .  $output . "     break;\n}";

            $output = "# BEGIN Hide My WP\n\n" . $output . "\n# END Hide My WP";

        else

            $output = __('Nothing to add for current settings.', self::slug);



        $output = $this->cleanup_config($output);





        $html = '';

        $desc = __('Add to Nginx config file to get all features of the plugin. <br>', self::slug);



        if (isset($_GET['nginx_config']) && $_GET['nginx_config']) {



            $html = sprintf('%s ', $desc);

            $html .= sprintf('<span class="description">

        <ol style="color:#ff9900">

        <li>Nginx vhosts config file usually located in /etc/nginx/sites-available/YOURSITE or /etc/nginx/sites-available/default or /etc/nginx/nginx.conf  </li>

        <li>Add HMWP rules within server{} block. You can add the rules just before the closing braces }.  </li>

        <li>Restart Nginx to see changes</li>

        <li>You may need to re-configure the server whenever you change settings or activate a new theme or plugin.</li>

        <li>If you use sub-directory for WP block you have to add that directory before all of below pathes (e.g. rewrite ^/wordpress/lib/(.*) /wordpress/wp-includes/$1 or rewrite ^/wordpress/(.*)\.php(.*) /wordpress/nothing_404_404)</li></ol></span><textarea readonly="readonly" onclick="" rows="5" cols="55" class="regular-text %1$s" id="%2$s" name="%2$s" style="%4$s">%3$s</textarea>', 'nginx_config_class', 'nginx_config', esc_textarea($output), 'width:95% !important;height:400px !important');





        } else {

            $html = '<a target="_blank" href="' . add_query_arg(array('die_message' => 'nginx')) . '" class="button">' . __('Nginx Configuration', self::slug) . '</a>';

            $html .= sprintf('<br><span class="description"> %s</span>', $desc);

        }





        return $html;

        //rewrite ^/assets/css/(.*)$ /wp-content/themes/roots/assets/css/$1 last;





    }	
    function load_this_plugin_first()

    {

        // ensure path to this file is via main wp plugin path

        $wp_path_to_this_file = preg_replace('/(.*)plugins\/(.*)$/', WP_PLUGIN_DIR . "/$2", __FILE__);

        $this_plugin = plugin_basename(trim($wp_path_to_this_file));

        if (is_multisite()) {

            global $current_blog;

            $active_plugins = array_keys(get_site_option('active_sitewide_plugins', array()));

            $codes = array_values(get_site_option('active_sitewide_plugins', array()));

        } else {

            $active_plugins = get_option('active_plugins', array());

        }



        $this_plugin_key = array_search($this_plugin, $active_plugins);



        if (in_array($this_plugin, $active_plugins) && $active_plugins[0] != $this_plugin) {

            array_splice($active_plugins, $this_plugin_key, 1);

            array_unshift($active_plugins, $this_plugin);

            if (is_multisite()) {

                $this_plugin_code = $codes[$this_plugin_key];

                array_splice($codes, $this_plugin_key, 1);

                array_unshift($codes, $this_plugin_code);



                update_site_option('active_sitewide_plugins', array_combine($active_plugins, $codes));

            } else {

                update_option('active_plugins', $active_plugins);

            }



        }



    }	
	
    function add_rewrite_rules($wp_rewrite)

    {

        global $wp_rewrite, $wp;



        if (is_multisite()) {

            global $current_blog;

            $sitewide_plugins = array_keys((array)get_site_option('active_sitewide_plugins', array()));

            $active_plugins = array_merge((array)get_blog_option(BLOG_ID_CURRENT_SITE, 'active_plugins'), $sitewide_plugins);

        } else {

            $active_plugins = get_option('active_plugins');

        }





        if ($this->opt('rename_plugins') == 'all')

            $active_plugins = get_option('hmw_all_plugins');





        if ($this->opt('replace_urls') || $this->auto_replace_urls) {

            $replace_urls = $this->h->replace_newline(trim($this->opt('replace_urls'), ' '), '|%|');

            $replace_lines = explode('|%|', $replace_urls);

            $replace_lines = array_merge($replace_lines, $this->auto_replace_urls);



            if ($replace_lines) {

                foreach ($replace_lines as $line) {



                    $replace_word = explode('==', $line);

                    if (isset($replace_word[0]) && isset($replace_word[1])) {



                        //Check whether last character is / or not to recgnize folders

                        $is_folder = false;

                        if (substr($replace_word[0], strlen($replace_word[0]) - 1, strlen($replace_word[0])) == '/')

                            $is_folder = true;



                        $replace_word[0] = trim($replace_word[0], '/ ');

                        $replace_word[1] = trim($replace_word[1], '/ ');



                        $is_block = false;

                        if ($replace_word[1] == 'nothing_404_404')

                            $is_block = true;





                        if (!$is_block) {

                            $this->top_replace_old[] = $replace_word[0];

                            $this->top_replace_new[] = $replace_word[1];

                        }



                        if ($is_block) {

                            //Swap words to make theme unavailable

                            $temp = $replace_word[0];

                            $replace_word[0] = $replace_word[1];

                            $replace_word[1] = $temp;

                        }



                        $replace_word[0] = str_replace(array('amp;', '%2F', '//', '.'), array('', '/', '/', '.'), $replace_word[0]);

                        $replace_word[1] = str_replace(array('.', 'amp;'), array('\.', ''), $replace_word[1]);



                        if ($is_folder) {

                            $new_non_wp_rules[$rule_1 . '/(.*)'] = $this->sub_folder . $rule_0 . '/$1' . $this->trust_key;

                        } else {

							$rule_0 = trim($replace_word[0], '/ ');

							$rule_1 = trim($replace_word[1], '/ ');

							$file_url = $this->sub_folder . $rule_0;

							if (strpos($file_url, '?') !== FALSE) {

								$new_non_wp_rules[$rule_1] = $file_url . str_replace('?', '&', $this->trust_key);

								;

							} else {

								$new_non_wp_rules[$rule_1] = $file_url . $this->trust_key;

							}

						}

                    }

                }

            }

        }





        //Order is important

        if ($this->opt('rename_plugins') && $this->opt('new_plugin_path') && $this->is_permalink()) {

            foreach ((array)$active_plugins as $active_plugin) {



                //Ignore itself or a plugin without folder

                if (!$this->h->str_contains($active_plugin, '/') || $active_plugin == self::main_file || strpos($active_plugin, 'elementor') !== FALSE)

                    continue;



                $new_plugin_path = trim($this->opt('new_plugin_path'), '/ ');



                $codename_this_plugin = $this->hash($active_plugin);



                $rel_this_plugin_path = trim(str_replace(site_url(), '', plugin_dir_url($active_plugin)), '/');

                //Allows space in plugin folder name

                $rel_this_plugin_path = $this->sub_folder . str_replace(' ', '\ ', $rel_this_plugin_path);



                $new_this_plugin_path = $new_plugin_path . '/' . $codename_this_plugin;

                $new_non_wp_rules[$new_this_plugin_path . '/(.*)'] = $rel_this_plugin_path . '/$1' . $this->trust_key;



                if (is_multisite()) {

                    if ($this->is_subdir_mu)

                        $new_this_plugin_path = '/' . $new_this_plugin_path;

                    $rel_this_plugin_path = $this->blog_path . str_replace($this->sub_folder, '', $rel_this_plugin_path);

                }



                $this->partial_replace_old[] = $rel_this_plugin_path . '/';

                $this->partial_replace_new[] = $new_this_plugin_path . '/';



                if ($this->opt('replace_javascript_path') > 1) {

                    $this->replace_old[] = str_replace('/', '\/', $rel_this_plugin_path . '/');

                    $this->replace_new[] = str_replace('/', '\/', $new_this_plugin_path . '/');

                }





            }

        }



        if ($this->opt('new_include_path') && $this->is_permalink()) {

            $rel_include_path = $this->sub_folder . trim(WPINC);

            $new_include_path = trim($this->opt('new_include_path'), '/ ');



            $new_non_wp_rules[$new_include_path . '/(.*)'] = $rel_include_path . '/$1' . $this->trust_key;



            if (is_multisite()) {

                $rel_include_path = $this->blog_path . str_replace($this->sub_folder, '', $rel_include_path);

                if ($this->is_subdir_mu)

                    $new_include_path = '/' . $new_include_path;

            }



            $this->partial_replace_old[] = $rel_include_path;

            $this->partial_replace_new[] = $new_include_path;

        }



        $rel_admin_path = $this->sub_folder . 'wp-admin';

        $new_admin_path = trim($this->opt('new_admin_path'), '/ ');





        if ($new_admin_path && $new_admin_path != 'wp-admin' && $this->is_permalink()) {



            /*  if (trim(get_option('hmwp_temp_admin_path'), ' /'))

                  $new_admin_path = trim(get_option('hmwp_temp_admin_path'), ' /');

              else

                  $new_admin_path = trim($this->opt('new_admin_path'), '/ ');*/



            $new_non_wp_rules[$new_admin_path . '/(.*)'] = $rel_admin_path . '/$1' . $this->trust_key;



            if (is_multisite()) {

                if ($this->is_subdir_mu)

                    $new_admin_path = '/' . $new_admin_path;

                $rel_admin_path = $this->blog_path . str_replace($this->sub_folder, '', $rel_admin_path);

            }

            //Add / to fix stylesheet and other 'wp-admin'

            //will break all Replace URLs to wp-admin plus all urls of it

            $this->admin_replace_old[] = $rel_admin_path . '/';

            $this->admin_replace_new[] = $new_admin_path . '/';





            //Fix config code for HMWP nginx / multisite, etc

            if (isset($_GET['page']) && $_GET['page'] == self::slug) {

                $this->admin_replace_old[] = $new_admin_path . '/$';

                $this->admin_replace_new[] = $rel_admin_path . '/$';



                $this->admin_replace_old[] = $new_admin_path . '/admin-ajax.php [QSA';

                $this->admin_replace_new[] = 'wp-admin/admin-ajax.php' . $this->trust_key . ' [QSA';



                $this->admin_replace_old[] = $new_admin_path . '/(!network';

                $this->admin_replace_new[] = 'wp-admin/(!network';



                $this->admin_replace_old[] = $new_admin_path . '/admin-ajax.php last;';

                $this->admin_replace_new[] = 'wp-admin/admin-ajax.php' . $this->trust_key . ' last;';

            }



        }





        if ($this->opt('new_upload_path') && $this->is_permalink()) {

            $upload_path = wp_upload_dir();



            if (is_ssl())

                $upload_path['baseurl'] = str_replace('http:', 'https:', $upload_path['baseurl']);



            if (is_multisite() && $current_blog->blog_id != BLOG_ID_CURRENT_SITE) {



                $upload_path_array = explode('/', $upload_path['baseurl']);

                array_pop($upload_path_array);

                array_pop($upload_path_array);

                $upload_path['baseurl'] = implode('/', $upload_path_array);



            }



            $rel_upload_path = $this->sub_folder . trim(str_replace(site_url(), '', $upload_path['baseurl']), '/');;

            $new_upload_path = trim($this->opt('new_upload_path'), '/ ');

            $new_non_wp_rules[$new_upload_path . '/(.*)'] = $rel_upload_path . '/$1' . $this->trust_key;



            if (is_multisite()) {

                $rel_upload_path = str_replace($this->sub_folder, '', $rel_upload_path);

                if ($this->is_subdir_mu)

                    $new_upload_path = str_replace($this->blog_path, '/', home_url($new_upload_path));

            }





            $this->replace_old[] = home_url($rel_upload_path);  //Fix external images problem



            if (is_multisite())

                $this->replace_new[] = $new_upload_path; //already added home_url!

            else

                $this->replace_new[] = home_url($new_upload_path);



            if ($this->opt('replace_javascript_path') > 2) {

                $this->replace_old[] = str_replace('/', '\/', $rel_upload_path);

                $this->replace_new[] = str_replace('/', '\/', $new_upload_path);

            }

        }





        if ($this->new_login_path && $this->new_login_path != 'wp-login.php' && $this->is_permalink()) {



            $rel_login_path = $this->sub_folder . '/wp-login.php';



            $this->new_login_path = trim($this->new_login_path, '/ ');

            $new_non_wp_rules[$this->new_login_path] = $rel_login_path . $this->trust_key;



            if (is_multisite()) {

                if ($this->is_subdir_mu)

                    $this->new_login_path = '/' . $this->new_login_path;

                $rel_login_path = $this->blog_path . str_replace($this->sub_folder, '', $this->new_login_path);

            }



//            $this->partial_replace_old[]=$rel_plugin_path;

//            $this->partial_replace_new[]=$new_plugin_path;





        }





        if ($this->opt('new_plugin_path') && $this->is_permalink()) {

            $rel_plugin_path = $this->sub_folder . trim(str_replace(site_url(), '', WP_SECURE_PLUGIN_URL), '/');



            $new_plugin_path = trim($this->opt('new_plugin_path'), '/ ');

            $new_non_wp_rules[$new_plugin_path . '/(.*)'] = $rel_plugin_path . '/$1' . $this->trust_key;



            if (is_multisite()) {

                if ($this->is_subdir_mu)

                    $new_plugin_path = '/' . $new_plugin_path;

                $rel_plugin_path = $this->blog_path . str_replace($this->sub_folder, '', $rel_plugin_path);

            }



            $this->partial_replace_old[] = $rel_plugin_path;

            $this->partial_replace_new[] = $new_plugin_path;



            if ($this->opt('replace_javascript_path') > 1) {

                $this->replace_old[] = str_replace('/', '\/', $rel_plugin_path);

                $this->replace_new[] = str_replace('/', '\/', $new_plugin_path);

            }

        }





        if ($this->add_auto_internal('css') && !isset($_POST['wp_customize']) && $this->is_permalink()) {

            $auto_path = '_auto\.css';



            //not multisite

            if ($this->sub_folder)

                $new_non_wp_rules[$auto_path] = add_query_arg('style_internal_wrapper', '1', $this->sub_folder) . str_replace('?', '&', $this->trust_key);

            else

                $new_non_wp_rules[$auto_path] = '/index.php?style_internal_wrapper=1' . str_replace('?', '&', $this->trust_key);



        }



        if ($this->add_auto_internal('js') && !isset($_POST['wp_customize']) && $this->is_permalink()) {

            $auto_path = '_auto\.js';



            //not multisite

            if ($this->sub_folder)

                $new_non_wp_rules[$auto_path] = add_query_arg('script_internal_wrapper', '1', $this->sub_folder) . str_replace('?', '&', $this->trust_key);

            else

                $new_non_wp_rules[$auto_path] = '/index.php?script_internal_wrapper=1' . str_replace('?', '&', $this->trust_key);



        }



        if ($this->opt('new_style_name') && $this->opt('new_theme_path')) {

            $new_style_path = trim($this->opt('new_theme_path'), ' /') . '/' . trim($this->opt('new_style_name'), '/ ');

            $new_style_path = str_replace('.', '\.', $new_style_path);

            $rel_theme_path = $this->sub_folder . trim(str_replace(site_url(), '', get_stylesheet_directory_uri()), '/');

            if ($this->sub_folder)

                $new_non_wp_rules[$new_style_path] = add_query_arg('style_wrapper', '1', $this->sub_folder) . str_replace('?', '&', $this->trust_key);

            else

                $new_non_wp_rules[$new_style_path] = '/index.php?style_wrapper=1' . str_replace('?', '&', $this->trust_key);



            if (trim($this->opt('new_style_name'), ' /') != 'style.css') {

                $old_style = trim($this->opt('new_theme_path'), ' /') . '/' . 'style\.css';

                $new_non_wp_rules[$old_style] = 'nothing_404_404' . $this->trust_key;

            }



            //We do not use _main in child themes on multisites instead we change all style.css to main.css

            //In single we use a different approach and style.css remains and minified for parent themes.

            if (is_multisite()) {

                $this->partial_preg_replace_old[] = '@/' . trim($this->opt('new_theme_path'), ' /') . '/([_0-9a-zA-Z-]+)/style.css@';

                $this->partial_preg_replace_new[] = '/' . trim($this->opt('new_theme_path'), ' /') . '/$1/' . trim($this->opt('new_style_name'), ' /');

            }

        }



        if ($this->auto_config_plugins && !isset($_POST['wp_customize']) && $this->is_permalink()) {

            $get_path = '_get/([A-Za-z0-9-_\.]+)/(.*)';

            //RewriteRule ^_get/([A-Za-z0-9-_\.]+)/(.*) /wp39/index.php?get_wrapper=1&_case=$1&_addr=$2&AK_wps_options=1234 [QSA,L]



            //not multisite

            if ($this->sub_folder)

                $new_non_wp_rules[$get_path] = add_query_arg('get_wrapper', '1', $this->sub_folder) . '&_case=$1&_addr=$2' . str_replace('?', '&', $this->trust_key);

            else

                $new_non_wp_rules[$get_path] = '/index.php?get_wrapper=1&_case=$1&_addr=$2' . str_replace('?', '&', $this->trust_key);



        }





        if ($this->opt('new_theme_path') && $this->is_permalink() && !isset($_POST['wp_customize'])) {

            $rel_theme_path = $this->sub_folder . trim(str_replace(site_url(), '', get_stylesheet_directory_uri()), '/');



            $new_theme_path = trim($this->opt('new_theme_path'), '/ ');

            $new_non_wp_rules[$new_theme_path . '/(.*)'] = $rel_theme_path . '/$1' . $this->trust_key;



            if (is_multisite()) {

                if ($this->is_subdir_mu)

                    $new_theme_path = '/' . $new_theme_path;

                $rel_theme_path_with_theme = trim(str_replace(site_url(), '', get_stylesheet_directory_uri()), '/');

                $rel_theme_path = $this->blog_path . str_replace('/' . get_stylesheet(), '', $rel_theme_path_with_theme); //without theme

            }



            $this->partial_replace_old[] = $rel_theme_path;

            $this->partial_replace_new[] = $new_theme_path;



            if ($this->opt('replace_javascript_path') > 0) {

                $this->replace_old[] = str_replace('/', '\/', $rel_theme_path);

                $this->replace_new[] = str_replace('/', '\/', $new_theme_path);

            }



            if (is_child_theme()) {

                //remove the end folder so we can replace it with parent theme

                $path_array = explode('/', $new_theme_path);

                array_pop($path_array);

                $path_string = implode('/', $path_array);



                if ($path_string)

                    $path_string = $path_string . '/';



                $parent_theme_new_path = $path_string . get_template();

                $rel_parent_theme_path = $this->sub_folder . trim(str_replace(site_url(), '', get_template_directory_uri()), '/');

                $parent_theme_new_path_with_main = $new_theme_path . '_main';



                if ($this->sub_folder)

                    $new_non_wp_rules[$parent_theme_new_path_with_main . '/style\.css'] = add_query_arg('parent_wrapper', '1', $this->sub_folder) . str_replace('?', '&', $this->trust_key);

                else

                    $new_non_wp_rules[$parent_theme_new_path_with_main . '/style\.css'] = '/index.php?parent_wrapper=1' . str_replace('?', '&', $this->trust_key);





                $new_non_wp_rules[$parent_theme_new_path . '/(.*)'] = $rel_parent_theme_path . '/$1' . $this->trust_key;

                $new_non_wp_rules[$parent_theme_new_path_with_main . '/(.*)'] = $rel_parent_theme_path . '/$1' . $this->trust_key;



                if (!is_multisite()) {

                    $this->partial_replace_old[] = $rel_parent_theme_path;

                    $this->partial_replace_new[] = $parent_theme_new_path_with_main;

                }



                if ($this->opt('replace_javascript_path') > 0) {

                    $this->replace_old[] = str_replace('/', '\/', $rel_parent_theme_path);

                    $this->replace_new[] = str_replace('/', '\/', $parent_theme_new_path_with_main);

                }

            }

        }





        if ($this->opt('replace_admin_ajax') && trim($this->opt('replace_admin_ajax'), '/ ') != 'admin-ajax.php' && trim($this->opt('replace_admin_ajax')) != 'wp-admin/admin-ajax.php' && $this->is_permalink()) {

            $rel_admin_ajax = $this->sub_folder . 'wp-admin/admin-ajax.php';

            $new_admin_ajax = trim($this->opt('replace_admin_ajax'), '/ ');



            $admin_ajax = str_replace('.', '\\.', $new_admin_ajax);



            $new_non_wp_rules[$admin_ajax] = $rel_admin_ajax . $this->trust_key;



            if (is_multisite()) {

                $rel_admin_ajax = str_replace($this->sub_folder, '', $rel_admin_ajax);

                $new_admin_ajax = $new_admin_ajax;

            }



            $this->replace_old[] = $rel_admin_ajax;

            $this->replace_new[] = $new_admin_ajax;



            $this->replace_old[] = str_replace('/', '\/', $rel_admin_ajax);

            $this->replace_new[] = str_replace('/', '\/', $new_admin_ajax);

        }



        if (trim($this->opt('new_content_path'), ' /') && trim($this->opt('new_content_path'), '/ ') != 'wp-content' && $this->is_permalink()) {

            $new_content_path = trim($this->opt('new_content_path'), ' /');

            $rel_content_path = $this->sub_folder . trim(str_replace(site_url(), '', WPS_CONTENT_URL), '/');



            $new_non_wp_rules[$new_content_path . '/(.*)'] = $rel_content_path . '/$1' . $this->trust_key;



            $this->replace_old[] = str_replace('/', '\/', $rel_content_path);

            $this->replace_new[] = str_replace('/', '\/', $new_content_path);

        }



        if ($this->opt('replace_comments_post') && trim($this->opt('replace_comments_post'), '/ ') != 'wp-comments-post.php' && $this->is_permalink()) {



            $rel_comments_post = $this->sub_folder . 'wp-comments-post.php';

            $new_comments_post = trim($this->options['replace_comments_post'], '/ ');

            $comments_post = str_replace('.', '\\.', $new_comments_post);



            $new_non_wp_rules[$comments_post] = $rel_comments_post . $this->trust_key;



            if (is_multisite()) {

                $new_comments_post = $new_comments_post;

                $rel_comments_post = str_replace($this->sub_folder, '', $rel_comments_post);

            }



            $this->replace_old[] = $rel_comments_post;

            $this->replace_new[] = $new_comments_post;

        }

        if ($this->hide_other_files && $this->is_permalink()) {

            $rel_content_path = $this->sub_folder . trim(str_replace(site_url(), '', WPS_CONTENT_URL), '/');

            $rel_plugin_path = $this->sub_folder . trim(str_replace(site_url(), '', WP_SECURE_PLUGIN_URL), '/');

            $rel_include_path = $this->sub_folder . trim(WPINC);



            //Fix an annoying strange bug in some webhosts (bright).

            $screenshot = '';

            if (!is_multisite()) {

                $rel_theme_path_with_theme = $this->sub_folder . trim(str_replace(site_url(), '', get_stylesheet_directory_uri()), '/');

                $rel_theme_path = str_replace('/' . get_stylesheet(), '', $rel_theme_path_with_theme);

                $screenshot = $rel_theme_path_with_theme . '/screenshot\.png|';

            }



            $style_path_reg = '';

            //  if (!is_multisite() && $this->opt('new_style_name') && $this->opt('new_style_name') != 'style.css' && !isset($_POST['wp_customize']))

            //      $style_path_reg = '|'.$rel_theme_path_with_theme.'/style\.css';



            //|'.$rel_plugin_path.'/index\.php|'.$rel_theme_path.'/index\.php'

            $new_non_wp_rules[$screenshot . $this->sub_folder . 'readme\.html|' . $this->sub_folder . 'license\.txt|' . $rel_content_path . '/debug\.log' . $style_path_reg . '|' . $rel_include_path . '/$'] = 'nothing_404_404' . $this->trust_key;

        }



        if ($this->disable_directory_listing && $this->is_permalink()) {

            $rel_content_path = $this->sub_folder . trim(str_replace(site_url(), '', WPS_CONTENT_URL), '/');

            $rel_include_path = $this->sub_folder . trim(WPINC);



            $new_non_wp_rules['(((' . $rel_content_path . '|' . $rel_include_path . ')/([A-Za-z0-9\-\_\/]*))|(wp-admin/(!network\/?)([A-Za-z0-9\-\_\/]+)))(\.txt|/)$'] = 'nothing_404_404' . $this->trust_key;

        }



        if ($this->opt('avoid_direct_access')) {

            $rel_plugin_path = $this->sub_folder . trim(str_replace(site_url(), '', WP_SECURE_PLUGIN_URL), '/');

            $rel_theme_path_with_theme = $this->sub_folder . trim(str_replace(site_url(), '', get_stylesheet_directory_uri()), '/');



            $white_list = explode(",", $this->opt('direct_access_except'));

            $white_list[] = 'wp-login.php';

            $white_list[] = 'index.php';

            $white_list[] = 'wp-admin/';



            if (get_option('hmwp_reset_token')) {

                $reset_url = $rel_plugin_path. '/' .dirname(HMW_FILE) . '/d.php';

                $white_list[] = $reset_url;

            }



            if ($this->new_login_path)

                $white_list[] = $this->new_login_path;



            if ($this->opt('exclude_theme_access'))

                $white_list[] = $rel_theme_path_with_theme . '/';

            if ($this->opt('exclude_plugins_access'))

                $white_list[] = $rel_plugin_path . '/';



            $block = true;

            $white_regex = '';

            foreach ($white_list as $white_file) {

                $white_regex .= $this->sub_folder . str_replace(array('.', ' '), array('\.', ''), $white_file) . '|';                     //make \. remove spaces

            }

            $white_regex = substr($white_regex, 0, strlen($white_regex) - 1); //remove last |

            $white_regex = str_replace(array("\n", "\r\n", "\r"), '', $white_regex);

            //ToDo: Maybe this is a better rule. but harder to implement with WP (Because of RewriteCond):

            //RewriteCond %{REQUEST_URI} !(index\.php|wp-content/repair\.php|wp-includes/js/tinymce/wp-tinymce\.php|wp-comments-post\.php|wp-login\.php|index\.php|wp-admin/)(.*)



            $new_non_wp_rules['(' . $white_regex . ')(.*)'] = '$1$2' . $this->trust_key;

            $new_non_wp_rules[$this->sub_folder . '(.*)\.php(.*)'] = 'nothing_404_404' . $this->trust_key;



        }

        add_filter('mod_rewrite_rules', array(&$this, 'mod_rewrite_rules'), 10, 1);





        if (isset($new_non_wp_rules) && $this->is_permalink())

            $wp_rewrite->non_wp_rules = array_merge($wp_rewrite->non_wp_rules, $new_non_wp_rules);



        return $wp_rewrite;



    }
    function wc_endpoint($req)

    {

        if ($this->h->str_contains($req, '_auto.') && isset($_REQUEST['_req']))

            return add_query_arg('wc-ajax', '%%endpoint%%', remove_query_arg(array('remove_item', 'add-to-cart', 'added-to-cart'), base64_decode(urldecode($_REQUEST['_req']))));

        return $req;

    }
    function add_auto_internal($type = 'css')

    {

        if ($type == 'css')

            return ($this->opt('new_theme_path') && ($this->opt('auto_internal') == 1 || $this->opt('auto_internal') == 3 || $this->opt('internal_css') || $this->auto_config_internal_css));

        elseif ($type == 'js')

            return ($this->opt('new_theme_path') && ($this->opt('auto_internal') >= 2 || $this->opt('internal_js') || $this->auto_config_internal_js || $this->auto_config_plugins));



        //auto_config_plugins require for woocommerce endpoint in ajax

    }	
    function opt($key)

    {

        if (isset($this->options[$key]))

            return $this->options[$key];

        return false;

    }	
    function init()

    {

        require_once('init.php');

    }	
	
    function global_html_filter($buffer)

    {



        $this->none_replaced_buffer = $buffer;



        //not replace for crons

        if (!$this->is_html($buffer) && isset($_GET['die_message']) || isset($_GET['style_internal_wrapper']) || isset($_GET['script_internal_wrapper']) || isset($_GET['style_wrapper']) || isset($_GET['get_wrapper']) || isset($_GET['parent_wrapper']) || isset($_GET['template_wrapper']) || isset($_GET['doing_wp_cron']))

            return $buffer;





        if (is_admin() && $this->admin_replace_old) {

            $buffer = str_replace($this->admin_replace_old, $this->admin_replace_new, $buffer);

            return $buffer;

        }




            if (is_admin())

                return $buffer;

  



        //first minify rocket then change other URLS

		if (defined('WP_ROCKET_VERSION')) {

			if (version_compare(WP_ROCKET_VERSION, '3.1') >= 0) {

				@define('WP_ROCKET_WHITE_LABEL_FOOTPRINT', 1);

			} else {

				@define('WP_ROCKET_WHITE_LABEL_FOOTPRINT', 1);

				if (function_exists('rocket_minify_process')) {

					$buffer = rocket_minify_process($buffer);

				}

			}

		}



		if ($this->opt('remove_html_comments') && !defined('DOING_AJAX')) {

            if ($this->opt('remove_html_comments') == 'simple') {

                $this->preg_replace_old[] = '/<!--(.*?)-->/';

                $this->preg_replace_new[] = ' ';

                $this->preg_replace_old[] = "%(\n){2,}%";

                $this->preg_replace_new[] = "\n";



            } elseif ($this->opt('remove_html_comments') == 'quick') {

                //comments and more than 2 space or line break will be remove. Simple & quick but not perfect!

                $this->preg_replace_old[] = '!/\*.*?\*/!s';

                $this->preg_replace_new[] = ' ';

                $this->preg_replace_old[] = '/\n\s*\n/';

                $this->preg_replace_new[] = ' ';

                $this->preg_replace_old[] = '/<!--(.*?)-->/';

                $this->preg_replace_new[] = ' ';

                $this->preg_replace_old[] = "%(\s){3,}%";

                $this->preg_replace_new[] = ' ';

                

            } elseif ($this->opt('remove_html_comments') == 'safe') {

                require_once('lib/class.HTML-minify.php');

                $min = new Minify_HTML($buffer, array('xhtml' => true));

                $buffer = $min->process();

            }

        }



        if ($this->top_replace_old)

            $buffer = str_replace($this->top_replace_old, $this->top_replace_new, $buffer);



        if ($this->opt('replace_in_html')) {

            $replace_in_html = $this->h->replace_newline(trim($this->opt('replace_in_html'), ' '), '|%|');

            $replace_lines = explode('|%|', $replace_in_html);



            if ($replace_lines) {

                foreach ($replace_lines as $line) {

                    $replace_word = explode('=', $line);



                    if (isset($replace_word[0]) && isset($replace_word[1])) {

                        $replace_word[0] = str_replace(array('[equal]', '[bslash]', '[new_line]'), array('=', "\\", "\n"), $replace_word[0]);



                        $replace_word[1] = str_replace(array('[equal]', '[bslash]', '[new_line]'), array('=', "\\", "\n"), $replace_word[1]);



                        $this->replace_old[] = trim($replace_word[0], ' ');

                        $this->replace_new[] = trim($replace_word[1], ' ');

                    }

                }

            }

        }



//good but problem to find exclude ie and src= styles

        if ($this->opt('auto_internal')) {



            //!isset($_GET['doing_wp_cron']) && !style_internal_wrapper

            $blog_id = get_current_blog_id();

            if (!is_multisite())

                $old = get_option('hmwp_internal_assets');

            else

                $old = get_blog_option($blog_id, 'hmwp_internal_assets');

            if ($old)

                $new = $old;

            else

                $new = array('css' => '', 'js' => '');

        }



        if ($this->opt('auto_internal') == 1 || $this->opt('auto_internal') == 3) {



            preg_match_all("@<style(.*?)>(.*?)</style>@is",//conflict if it have inline ie tags

                $buffer,

                $matches,

                PREG_PATTERN_ORDER);



            $new_css = '';

            if (is_array($matches)) {

                for ($i = 0; $i < count($matches[1]); $i++) {

                    if (!$matches[1][$i] || (!stristr("print'", $matches[1][$i]) && !stristr('print"', $matches[1][$i])))

                        $new_css .= $matches[2][$i] . "\n";

                }

            }



            //or is_home is_archive is_single is_author is_feed

            if ($new_css)

                $new['css'] = $new_css;



            $this->preg_replace_old[] = "@<style(.*?)>(.*?)</style>@is"; //prints will be removed but not remain|conflict if had inline ie tags

            $this->preg_replace_new[] = " ";

        }



        if ($this->opt('auto_internal') >= 2) {



            preg_match_all("@<script(.*?)>(.*?)</script>([\s]*\<\!\[)?@is",  //still not <!--<![

//conflict with ie conditional tag will be added

                $buffer,

                $matches,

                PREG_PATTERN_ORDER);



            $new_js = '';

            if (is_array($matches)) {

                for ($i = 0; $i < count($matches[1]); $i++) { //should be tested

                    if (!$matches[1][$i] || (!stristr("src=", $matches[1][$i]) && !stristr('<![', $matches[3][$i])))

                        $new_js .= $matches[2][$i] . "\n";

                }

            }



            //or is_home is_archive is_single is_author is_feed

            if ($new_js)

                $new['js'] = $new_js;



            $this->preg_replace_old[] = "@(<s2cript[^>]*>)(.*?)(</script>)@is";

            $this->preg_replace_new[] = "$1$3"; //src will remain the same

        }



        if (isset($new) && $new && $new != $old) {



            if (!is_multisite())

                update_option('hmwp_internal_assets', $new);

            else

                update_blog_option($blog_id, 'hmwp_internal_assets', $new);

        }





        if ($this->opt('cdn_path')) {



            if (trim($this->opt('new_theme_path'), ' /')) {

                $this->replace_old[] = site_url(trim($this->opt('new_theme_path'), ' /'));

                $this->replace_new[] = trim($this->opt('cdn_path'), '/ ') . '/' . trim($this->opt('new_theme_path'), ' /');



            } else {

                $this->replace_old[] = site_url(str_replace(ABSPATH, '', WP_CONTENT_DIR . '/themes'));

                $this->replace_new[] = trim($this->opt('cdn_path'), '/ ') . '/' . str_replace(ABSPATH, '', WP_CONTENT_DIR . '/themes');

            }



            if (trim($this->opt('new_plugin_path'), ' /')) {

                $this->replace_old[] = site_url(trim($this->opt('new_plugin_path'), ' /'));

                $this->replace_new[] = trim($this->opt('cdn_path'), '/ ') . '/' . trim($this->opt('new_plugin_path'), ' /');



            } else {

                $this->replace_old[] = site_url(str_replace(ABSPATH, '', WP_PLUGIN_DIR));

                $this->replace_new[] = trim($this->opt('cdn_path'), '/ ') . '/' . site_url(str_replace(ABSPATH, '', WP_PLUGIN_DIR));

            }



            if (trim($this->opt('new_include_path'), ' /')) {

                $this->replace_old[] = site_url(trim($this->opt('new_include_path'), ' /'));

                $this->replace_new[] = trim($this->opt('cdn_path'), '/ ') . '/' . trim($this->opt('new_include_path'), ' /');



            } else {

                $this->replace_old[] = site_url(WPINC);

                $this->replace_new[] = trim($this->opt('cdn_path'), '/ ') . '/' . WPINC;

            }





            if (trim($this->opt('new_upload_path'), ' /')) {

                $this->replace_old[] = site_url(trim($this->opt('new_upload_path'), ' /'));

                $this->replace_new[] = trim($this->opt('cdn_path'), '/ ') . '/' . trim($this->opt('new_upload_path'), ' /');



            } else {

                $this->replace_old[] = site_url('wp-content/uploads');

                $this->replace_new[] = trim($this->opt('cdn_path'), '/ ') . '/' . 'wp-content/uploads';

            }

        }





        if ($this->opt('replace_mode') == 'safe' && $this->partial_replace_old)

            $buffer = str_replace($this->partial_replace_old, $this->partial_replace_new, $buffer);



        if ($this->opt('replace_mode') == 'safe' && $this->partial_preg_replace_old)

            $buffer = preg_replace($this->partial_preg_replace_old, $this->partial_preg_replace_new, $buffer);





        if ($this->replace_old)

            $buffer = str_replace($this->replace_old, $this->replace_new, $buffer);



        if ($this->preg_replace_old)

            $buffer = preg_replace($this->preg_replace_old, $this->preg_replace_new, $buffer);



        return $buffer;



    }	
    public function block_access(){
		include_once(ABSPATH . '/wp-includes/pluggable.php');
		status_header( 404 );
		nocache_headers();

		$headers = array('X-Pingback' => get_bloginfo('pingback_url'));
		$headers['Content-Type'] = get_option('html_type') . '; charset=' . get_option('blog_charset');
		foreach( (array) $headers as $name => $field_value )
			@header("{$name}: {$field_value}");


			$response = @wp_remote_get( home_url('/nothing_404_404') );
			if ( ! is_wp_error($response) )
				echo $response['body'];
			else
				wp_redirect( home_url('/404_Not_Found')) ;

		die();
    }
	
	    function is_html($content)

    { // is_html or json or xml



        if (strlen($content) > 1000) {

            $content = substr($content, 0, 1000);

        }



        $content = ltrim($content, "\x00\x09\x0A\x0D\x20\xBB\xBF\xEF");



        return stripos($content, '{[') !== false || stripos($content, '{"') !== false || stripos($content, '<?xml') !== false || stripos($content, '<html') !== false || stripos($content, '<!DOCTYPE') !== false;

    }
}
