<?php
/**
 * Fired during plugin activation.
 *
 * This class defines all code necessary to run during the plugin's activation.
 *
 * @since      1.0.0
 * @package    WpSecure
 * @subpackage WpSecure/includes
 * @author     WpSecure <contact@WpSecure.com>
 */
class WpSecure_Activator {

	public static function activate($network_wide) {
		global $wpdb;
		$sql = array();
		
		$sql[] = "DROP TABLE IF EXISTS `".$wpdb->prefix."secure_brute_logs`";
		
		$sql[] = "CREATE TABLE `".$wpdb->prefix."secure_brute_logs` (
					`username` varchar(255) NOT NULL DEFAULT '',
					`time` int(10) NOT NULL DEFAULT '0',
					`count` int(10) NOT NULL DEFAULT '0',
					`lockout` int(10) NOT NULL DEFAULT '0',
					`ip` varchar(255) NOT NULL DEFAULT '',
					`url` varchar(255) NOT NULL DEFAULT '',
					UNIQUE KEY `ip` (`ip`)
				) DEFAULT CHARSET=utf8;";

		foreach($sql as $sk => $sv){
			$wpdb->query($sv);
		}
		$wpsecure = get_option('wps_options',false); 
		if(!$wpsecure){
			$default = array
			(
				'replace_javascript_path' => 3,
				'replace_wpnonce' => '',
				'replace_mode' => 'safe',
				'custom_404' => 0,
				'custom_404_page' => '',
				'login_query' => 'wps_options',
				'admin_key' => '1234',
				'remove_feed_meta' => 'on',
				'remove_other_meta' => 'on',
				'remove_default_description' => 'on',
				'remove_ver_scripts' => 'on',
				'direct_access_except' => 'index.php, wp-includes/js/tinymce/wp-tinymce.php, xmlrpc.php, wp-cron.php',
				'new_theme_path' => '/skin',
				'new_style_name' => 'main.css',
				'style_expiry_days' => 3,
				'new_include_path' => '/other',
				'new_plugin_path' => '/ext',
				'new_upload_path' => '/file',
				'replace_comments_post' => '',
				'replace_admin_ajax' => 'ajax',
				'new_content_path' => 'inc',
				'author_enable' => 1,
				'author_base' => '',
				'author_query' => '',
				'feed_enable' => 1,
				'feed_base' => '',
				'feed_query' => '',
				'post_enable' => 1,
				'post_base' => '/%year%/%monthnum%/%day%/%postname%/',
				'post_query' => '',
				'page_enable' => 1,
				'page_base' => '',
				'page_query' => '',
				'paginate_enable' => 1,
				'paginate_base' => '',
				'paginate_query' => '',
				'category_enable' => 1,
				'category_base' => '',
				'category_query' => '',
				'tag_enable' => 1,
				'tag_base' => '',
				'tag_query' => '',
				'search_enable' => 1,
				'search_base' => '',
				'search_query' => '',
				'nice_search_redirect' => '',
				'import_options' => '',
				'export_options' => '',
				'debug_report' => '',
				'minify_new_style' => 'safe',
				'clean_new_style' => '',
				'rename_plugins' => '',
				'separator2' => '',
				'author_without_base' => '',
				'disable_archive' => '',
				'disable_other_wp' => '',
				'trusted_user_roles' => '',
				'antispam' => 'on',
				'avoid_direct_access' => '',
				'enable_ids' => 'on',
				'ids_mode' => 0,
				'ids_level' => 0,
				'log_ids_min' => 5,
				'block_ids_min' => 20,
				'cdn_path' => '',
				'help_trust_network' => 'on',
				'trust_network' => 'on',
				'exception_fields' => 'REQUEST.permalink_structure[new_line]POST.permalink_structure[new_line]REQUEST.selection[new_line]POST.selection[new_line]REQUEST.content[new_line]POST.content[new_line]REQUEST.__utmz[new_line]COOKIE.__utmz[new_line]REQUEST.s_pers[new_line]COOKIE.s_pers[new_line]REQUEST.user_pass[new_line]POST.user_pass[new_line]REQUEST.pass1[new_line]POST.pass1[new_line]REQUEST.pass2[new_line]POST.pass2[new_line]REQUEST.password[new_line]POST.password[new_line]POST.wps_options.%[new_line]REQUEST.wps_options.%[new_line]POST.%import%[new_line]REQUEST.%import%[new_line]REQUEST.newcontent[new_line]POST.newcontent[new_line]REQUEST.remember_%',
			);			
			
			$wpsecure['new_login_url'] = '';
			$wpsecure['admin_redirect_slug'] = '';
			
			$wpsecure['hide_admin']= '';
			$wpsecure['full_hide'] = '';
			$wpsecure['hide_other_files'] = '';
			$wpsecure['disable_directory_listing'] = '';
			$wpsecure['disable_canonical_redirect'] = '';
			$wpsecure['hide_popular_plugin'] = '';
				
			$lockout_time = 15 * 60;
			$lockouts_extend = 24 * 60 * 60;
			$reset_retries = 24 * 60 * 60;
			
			$wpsecure['max_retries']    = 3;
			$wpsecure['lockout_time']   = 900;
			$wpsecure['max_lockouts']   = 5;
			$wpsecure['lockouts_extend']= 86400;
			$wpsecure['reset_retries']  = 86400;
			$wpsecure['notify_email']   = 0;
			$wpsecure['notify_email_address']= '';	
			

			$wpsecure['pin_code']  = '';
		    $wpsecure_full = array_merge($default,$wpsecure);
			update_option('wps_options',$wpsecure_full);
		}
	}
	

}
