<?php
/**
 *
 * @link              http://wpsecure.com
 * @since             1.0.0
 * @package           WP Secure
 *
 * @wordpress-plugin
 * Plugin Name:       WP Secure
 * Plugin URI:        http://wpsecure.com
 * Description:       Security plugin that helps people to protect their websites.
 * Version:           1.0.0
 * Author:            WpSecure
 * Author URI:        http://wpsecure.com
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       wpsecure
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}
global $wpdb;
/**
 * Currently plugin version.
 * Start at version 1.0.0 and use SemVer - https://semver.org
 * Rename this for your plugin and update it as you release new versions.
 */
define('WPS_VERSION', '1.0.0' );
define('WPS_PLUGIN_PATH', plugin_dir_path(__FILE__));
define('WPS_PLUGIN_FILE', __FILE__);
define('WPS_PLUGIN_URL', plugin_dir_url( __FILE__));
define('WPS_SLUG', 'wpsecure');

define('WPS_TITLE', 'WP Secure');

define('WPS_PATH', dirname(__FILE__));

define('WPS_DIR', basename(WPS_PATH));

define('WPS_URL', plugins_url() . '/' . WPS_DIR);

define('WPS_FILE', plugin_basename(__FILE__));



if (is_ssl()) {

    define('WPS_CONTENT_URL', str_replace('http:', 'https:', WP_CONTENT_URL));

    define('WP_SECURE_PLUGIN_URL', str_replace('http:', 'https:', WP_PLUGIN_URL));

} else {

    define('WPS_CONTENT_URL', WP_CONTENT_URL);

    define('WP_SECURE_PLUGIN_URL', WP_PLUGIN_URL);

}
/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-wpsecure-activator.php
 */
function activate_wpsecure($network_wide) {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-wpsecure-activator.php';
	WpSecure_Activator::activate($network_wide);
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-wpsecure-deactivator.php
 */
function deactivate_wpsecure() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-wpsecure-deactivator.php';
	WpSecure_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_wpsecure' );
register_deactivation_hook( __FILE__, 'deactivate_wpsecure' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path( __FILE__ ) . 'includes/class-wpsecure.php';
//require plugin_dir_path( __FILE__ ) . 'includes/class-wpsecure-brute.php';

/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
 

function run_wpsecure() {

	$wpsecure = new WpSecure();
	$wpsecure->run();

}
run_wpsecure();

